/**@author Javier Matito Bernechea*/



// definicion de las importaciones
import java.io.*;
import java.applet.*;
import java.awt.*;
import java.util.Stack;
import java.awt.event.*;



//-----------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------



//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
//Definicion de las clases que embeben los datos del programa 
//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
/*Definicion de la clase del arbol sintactico*/
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//esta clase almacena la estructura de arbol sintactico de la expresion matematica 
/**@see ArbolSintactico*/
class ArbolSintactico 
{
 //variables de la clase
 private int regla;/**representa a la regla de la que este arbol forma parte*/
 private int token;/**representa el tipo de parte de la gramatica que este arbol es sea terminal o no terminal*/
 private int evento;/**representa el numero de evento con que se mete en pila */
 private ArbolSintactico hermano;/**representa el arbol sintactico hermano de este*/
 private ArbolSintactico hijo;/**representa al arbol sintactico hijo de este*/
 /**representa la informacion del nodo sirve para sacar los mensajes en pantalla*/
 private String info;
 /**representa el string que puede contener el nodo si el nodo es un string*/
 private String st;
 
 /**definicion del constructor*/
 ArbolSintactico(ArbolSintactico hermano,ArbolSintactico hijo,int regla,int token,String info,int evento)
 {this.hermano=hermano;
  this.hijo=hijo;
  this.regla=regla;
  this.token=token;
  this.info=info;
  this.evento=evento;
   
 };


    /**Funciones auxiliares que escriben en el fichero los tokens de contenido del arbol sintactico*/
 private void escribeTokenCont(TextArea salida)
    {//escribir las reglas de contenido, es decir los tokens
	// rellenar
      try 
      {
        if((this.token()>15))
	    {
             if((this.token()>49&&this.token()<92)||(this.token()>99)||(this.token()>32&&this.token()<37)||(this.token()==85)||(this.token()==86)||(this.token()==88)||(this.token()==89)||(this.token()==92)||(this.token()==93)||(this.token()>95&&this.token()<100))
	     {salida.insert(this.devuelveSt()+"\n",salida.getText().indexOf("</BODY>"));
             }
             else
	     {salida.insert(this.devuelveSt(),salida.getText().indexOf("</BODY>"));
             };
         };
      }
     catch(NullPointerException e)
	 {};
      
    };

 private void escribeCont( TextArea salida)
    {if(this.hijo()==null)
	// si el arbol no tiene hijos sera un nodo hoja
	{
         if(this.hermano()==null)
	     {//si no tiene hermanos se escribe lo que corresponda al token
              this.escribeTokenCont(salida);
             }
         else
             {//si tiene hermanos se escribe lo que correponde al token
		 //y se escribe lo del hermano
               this.escribeTokenCont(salida);
               this.hermano().escribeCont(salida);
             };
        }
    else//si tiene hijos sera un nodo intermedio
	{if(this.hermano()==null)//si no tiene hermanos se escribe lo correspondiente al nodo 
	    //se escribe lo de sus hijos
	     {this.escribeTokenCont(salida);
              this.hijo().escribeCont(salida);
             }
	else// si tiene hermanos se escribe lo del nodo lo de los hijos y lo del hermano
	      {this.escribeTokenCont(salida);
               this.hijo().escribeCont(salida);
               this.hermano().escribeCont(salida);
              };
         };
    };   

 public void escribe(TextArea file)
    {
     file.insert("<MATH>\n",file.getText().indexOf("</BODY>")); 
     this.escribeCont(file);
     file.insert("</MATH>\n",file.getText().indexOf("</BODY>")); 
    };
    /**Funciones auxiliares que escriben en el fichero los tokens de contenido del arbol sintactico*/
 private void escribeTokenConta(TextArea salida)
    {//escribir las reglas de contenido, es decir los tokens
	// rellenar
      int ind =salida.getCaretPosition();
      try 
      {
        if((this.token()>15))
	    {
             if((this.token()>49&&this.token()<92)||(this.token()>99)||((this.token()>32)&&(this.token()<37))||((this.token()>85)&&(this.token()<90))||(this.token()==92)||(this.token()==93)||((this.token()>95)&&(this.token()<100)))
	     {salida.insert(this.devuelveSt()+"\n",salida.getCaretPosition());
              salida.setCaretPosition(ind+this.devuelveSt().length()+1);
             }
             else
	     {salida.insert(this.devuelveSt(),salida.getCaretPosition());
              salida.setCaretPosition(ind+this.devuelveSt().length());
             };
         };
      }
     catch(NullPointerException e)
	 {};
      
    };

 private void escribeConta( TextArea salida)
    {if(this.hijo()==null)
	// si el arbol no tiene hijos sera un nodo hoja
	{
         if(this.hermano()==null)
	     {//si no tiene hermanos se escribe lo que corresponda al token
              this.escribeTokenConta(salida);
             }
         else
             {//si tiene hermanos se escribe lo que correponde al token
		 //y se escribe lo del hermano
               this.escribeTokenConta(salida);
               this.hermano().escribeConta(salida);
             };
        }
    else//si tiene hijos sera un nodo intermedio
	{if(this.hermano()==null)//si no tiene hermanos se escribe lo correspondiente al nodo 
	    //se escribe lo de sus hijos
	     {this.escribeTokenConta(salida);
              this.hijo().escribeConta(salida);
             }
	else// si tiene hermanos se escribe lo del nodo lo de los hijos y lo del hermano
	      {this.escribeTokenConta(salida);
               this.hijo().escribeConta(salida);
               this.hermano().escribeConta(salida);
              };
         };
    };   

 public void escribea(TextArea file)
    {int ind=file.getCaretPosition();
     file.insert("<MATH>\n",file.getCaretPosition()); 
     file.setCaretPosition(ind+7);
     this.escribeConta(file);
     file.insert("</MATH>\n",file.getCaretPosition()); 
     
    };


 // Funciones que operan sobre las variables de clase
   

 public String devuelveInfo()
    {return info;
    };
    /**Funcion que devuelve el hijo del arbol */
 
 public ArbolSintactico hijo()
    {return hijo;
    }; 
    /**Funcion que devuelve el hermano del arbol*/
 
 public ArbolSintactico hermano()
    {return hermano;
    };
    /**Funcion que devuelve el token */
 
 public int token()
    {return token;
    }; 
    /**Funcion que devuelve la regla*/
 
 public int regla()
    {return regla;
    };
 public void estableceSt(String st)
    {this.st=st;
    }; 
 public String devuelveSt()
    {return st;};
 public void estableceHijo(ArbolSintactico hijo)
    {this.hijo=hijo;};
 public void estableceHermano(ArbolSintactico hermano)
    {this.hermano=hermano;}; 
 public void estableceRegla(int regla)
    {this.regla=regla;};
 public void estableceToken(int token)
    {this.token=token;};
 public void estableceInfo(String info)
    {this.info=info;};
 public void estableceEvento(int evento)
    {this.evento=evento;};
public int devuelveEvento()
    {return evento;};
}
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//Final de las clase arbol sintactico
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^



//-----------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------

//-----------------------------------------------------------------------------------------
//Definicion de la clase que define el dialogo del menu matematico
//-----------------------------------------------------------------------------------------
class DialogMat extends Dialog implements ActionListener
{
  //Definicion del frame padre
 private MenuFrame padre;    
 //definicion de las opciones que debe tener el menu de expresiones matematicas
 //-------------------------------------------------------------------------------------
  private  List listaContainer;
  private  List listaApplybody;
  private  List listaRelnbody;
  private  List listaIspdomain;
  private  List listaCondition;
  private  List listaNaryop;
  private  List listaIspop;
  private  List listaBinaryrel;
  private  List listaNaryrel;
  private  List listaBvar;
  private  List listaLogicopquotant;
  private  List listaString;
  private  Button ultimafila;
  private  Button otrafila;
  private  Button especifcond;
  private  Button especifscond;
  private  Button ultimoarg;
  private  Button otroarg;
  private  Button ultimavar;
  private  Button otravar;
    //Definicion de los paneles en que se meten los menus matematicos   
  private  Panel plistaContainer;
  private  Panel plistaApplybody;
  private  Panel plistaRelnbody;
  private  Panel plistaIspdomain;
  private  Panel plistaCondition;
  private  Panel plistaNaryop;
  private  Panel plistaIspop;
  private  Panel plistaBinaryrel;
  private  Panel plistaNaryrel;
  private  Panel plistaBvar;
  private  Panel plistaLogicopquotant;
  private  Panel plistaString;
  private  Panel fila;
  private  Panel arg;
  private  Panel cond;
  private  Panel var;
    
  public  DialogMat(MenuFrame padre)
    {super(padre,"Menu Matematico",false);
     this.padre=padre;
    //definicion del layout del menu matematico
    setLayout(new CardLayout());
    //Inicializacion de los menus matematicos
    //definicion de la inicializacion de las opciones del menu de expresiones matematicas
     listaContainer=new List(8);
     listaContainer.add("variable");
     listaContainer.add("variable con subindice");
     listaContainer.add("variable con superindice");
     listaContainer.add("numero real");
     listaContainer.add("numero entero");
     listaContainer.add("numero racional");
     listaContainer.add("numero complejo cartesiano");
     listaContainer.add("numero  complejo polar");
     listaContainer.add("constante");
     listaContainer.add("aplicacion de un operador o funcion a una lista de argumentos");
     listaContainer.add("aplicacion de una relacion a una lista de argumentos");
     listaContainer.add("intervalo abierto-cerrado");
     listaContainer.add("intervalo abierto");
     listaContainer.add("intervalo cerrado");
     listaContainer.add("intervalo cerrado abierto");
     listaContainer.add("lista");
     listaContainer.add("matriz");
     listaContainer.add("conjunto");
     listaContainer.add("vector");
     //otra lista
     listaApplybody=new List(8);
     listaApplybody.add("inversa");
     listaApplybody.add("identidad");
     listaApplybody.add("valor absoluto");
     listaApplybody.add("conjugado");
     listaApplybody.add("exponencial");
     listaApplybody.add("factorial");
     listaApplybody.add("menos unario");
     listaApplybody.add("seno");
     listaApplybody.add("coseno");
     listaApplybody.add("tangente");
     listaApplybody.add("secante");
     listaApplybody.add("cosecante");
     listaApplybody.add("cotangente");
     listaApplybody.add("seno hiperbolico");
     listaApplybody.add("coseno hiperbolico");
     listaApplybody.add("tangente hiperbolica");
     listaApplybody.add("secante hiperbolica");
     listaApplybody.add("cosecante hiperbolica");
     listaApplybody.add("cotangente hiperbolica"); 
     listaApplybody.add("arcoseno");
     listaApplybody.add("arcocoseno");
     listaApplybody.add("arcotangente");
     listaApplybody.add("determinante");
     listaApplybody.add("transpuesta");
     listaApplybody.add("logaritmo neperiano");
     listaApplybody.add("negacion logica");
     listaApplybody.add("cociente");
     listaApplybody.add("division");
     listaApplybody.add("menos binario");
     listaApplybody.add("potencia");
     listaApplybody.add("resto de division");
     listaApplybody.add("diferencia de conjuntos");
     listaApplybody.add("implicacion logica"); 
     listaApplybody.add("operador o funcion  n-ario");
     listaApplybody.add("operador o funcion n-ario especificando condicion");
     listaApplybody.add("sumatorio, producto o integral especificando dominio y variable");
     listaApplybody.add("sumatorio, producto o integral especificando dominio");
     listaApplybody.add("sumatorio, producto o integral especificando variable");
     listaApplybody.add("sumatorio, producto o integral sin especificaciones");
     listaApplybody.add("derivada sobre funcion de una sola variable");
     listaApplybody.add("derivada parcial");
     listaApplybody.add("logaritmo especificando base");
     listaApplybody.add("logaritmo base 10");
     listaApplybody.add("momento estadistico espcificando orden");
     listaApplybody.add("momento estadistico orden 1");
     listaApplybody.add("raiz especificando grado");
     listaApplybody.add("raiz cuadrada"); 
     listaApplybody.add("limite");
     listaApplybody.add("limite con condicion");
     listaApplybody.add("cuantificador logico con condicion aplicado a operador o funcion con lista de argumentos");
     listaApplybody.add("cuantificador logico con condicion aplicado a relacion con lista de argumentos");
     listaApplybody.add("cuantificador logico aplicado a operador con lista de argumentos");
     listaApplybody.add("cuantificador logico aplicado a relacion con lista de argumentos"); 
     //otra lista
     listaRelnbody=new List(4);
     listaRelnbody.add("relacion binaria con condicion");
     listaRelnbody.add("relacion n-aria con condicion");
     listaRelnbody.add("relacion binaria");
     listaRelnbody.add("relacion n-aria"); 
     //otra lista
     listaIspdomain=new List(6);
     listaIspdomain.add("especificar limite superior e inferior");
     listaIspdomain.add("especificar limite inferior"); 
     listaIspdomain.add("especificar limite superior");
     listaIspdomain.add("especificar intervalo abierto-cerrado");
     listaIspdomain.add("especificar intervalo abierto");
     listaIspdomain.add("especificar intervalo cerrado");
     listaIspdomain.add("especificar intervalo cerrado-abierto");
     listaIspdomain.add("especificar condicion");
     //otra lista
     listaCondition=new List(4);
     listaCondition.add("especificar condicion con operador o funcion aplicado a una lista de argumentos");
     listaCondition.add("especificar condicion con relacion aplicada a una lista de argumentos");
     listaCondition.add("especificar condicion con un conjunto");
     //otra lista
     listaNaryop=new List(5);
     listaNaryop.add("suma");
     listaNaryop.add("multiplicacion");
     listaNaryop.add("maximo");
     listaNaryop.add("minimo");
     listaNaryop.add("maximo comun divisor");
     listaNaryop.add("media");
     listaNaryop.add("desviacion tipica");
     listaNaryop.add("varianza");
     listaNaryop.add("mediana");
     listaNaryop.add("moda"); 
     listaNaryop.add("seleccion en matriz");
     listaNaryop.add("and logico");
     listaNaryop.add("or logico");
     listaNaryop.add("xor logico");
     listaNaryop.add("union de conjuntos");
     listaNaryop.add("interseccion de conjuntos");
     //otra lista
     listaIspop=new List(4);
     listaIspop.add("integral");
     listaIspop.add("sumatorio");
     listaIspop.add("producto");
     //otra lista
     listaBinaryrel=new List(4);
     listaBinaryrel.add("no igual");
     listaBinaryrel.add("relacion de conjuntos pertenece");
     listaBinaryrel.add("relacion de conjuntos no pertenece");
     listaBinaryrel.add("relacion de conjuntos no subcojunto");
     listaBinaryrel.add("relacion de conjuntos no subconjunto propio");
     listaBinaryrel.add("relacion tiende hacia ->");
     //otra lista
     listaNaryrel=new List(4);  
     listaNaryrel.add("igual"); 
     listaNaryrel.add("menor o igual");
     listaNaryrel.add("menor que");
     listaNaryrel.add("mayor o igual");
     listaNaryrel.add("mayor que");
     listaNaryrel.add("relacion de conjuntos subconjunto");
     listaNaryrel.add("relacion de conjuntos subconjunto propio");     
     //otra lista
     listaBvar =new List(4);
     listaBvar.add("variable especificando grado");
     listaBvar.add("variable con subindice especificando grado");
     listaBvar.add("variable con superindice especificando grado");
     listaBvar.add("variable");
     listaBvar.add("variable con subindice");
     listaBvar.add("variable con superindice");
     //otra lista
     listaLogicopquotant =new List(3);
     listaLogicopquotant.add("cuantificador logico paratodo");
     listaLogicopquotant.add("cuantificador logico existe");
     //otra lista
     listaString =new List(8);
     listaString.add("definicion a traves de teclado");
     listaString.add("letra alpha");
     listaString.add("letra beta");
     listaString.add("letra chi");
     listaString.add("letra delta");
     listaString.add("letra epsiv");
     listaString.add("letra eta");
     listaString.add("letra gamma");
     listaString.add("letra iota");
     listaString.add("letra kappa");
     listaString.add("letra lambda");
     listaString.add("letra mu");
     listaString.add("letra nu");
     listaString.add("letra omega");
     listaString.add("letra omicron");
     listaString.add("letra phi");
     listaString.add("letra pi");
     listaString.add("letra psi");
     listaString.add("letra rho");
     listaString.add("letra sigma");
     listaString.add("letra tau");
     listaString.add("letra theta");
     listaString.add("letra upsi");
     listaString.add("letra xi");
     listaString.add("letra zeta");      
     //inicializacion de los botones del menu de espresiones matematicas
    ultimafila=new Button("ultimafila");
    otrafila=new Button ("otrafila");
    especifcond=new Button ("especifar con condicion");
    especifscond=new Button ("especifar sin condicion");
    ultimoarg=new Button ("ultimo argumento");
    otroarg =new Button ("otro argumento");
    ultimavar =new Button ("ultima variable");
    otravar =new Button ("otra variable");
    //incializacion de los paneles
    plistaContainer=new Panel();
    plistaContainer.add(listaContainer);
    plistaApplybody=new Panel();
    plistaApplybody.add(listaApplybody);
    plistaRelnbody=new Panel();
    plistaRelnbody.add(listaRelnbody);
    plistaIspdomain=new Panel();
    plistaIspdomain.add(listaIspdomain);
    plistaCondition=new Panel();
    plistaCondition.add(listaCondition);
    plistaNaryop=new Panel();
    plistaNaryop.add(listaNaryop);
    plistaIspop=new Panel();
    plistaIspop.add(listaIspop);
    plistaBinaryrel=new Panel();
    plistaBinaryrel.add(listaBinaryrel);
    plistaNaryrel=new Panel();
    plistaNaryrel.add(listaNaryrel);
    plistaBvar=new Panel();
    plistaBvar.add(listaBvar);
    plistaLogicopquotant=new Panel();
    plistaLogicopquotant.add(listaLogicopquotant);
    plistaString= new Panel();
    plistaString.add(listaString);
    Panel fila=new Panel();
    fila.add(otrafila);
    fila.add(ultimafila);
    Panel arg=new Panel();
    arg.add(otroarg);
    arg.add(ultimoarg);
    Panel cond=new Panel();
    cond.add(especifscond);
    cond.add(especifcond);
    Panel var=new Panel();
    var.add(otravar);
    var.add(ultimavar);
    //inclusion de los paneles al menu
    add("",plistaContainer);
    add("",plistaApplybody);
    add("",plistaRelnbody);
    add("",arg);
    add("",var);
    add("",plistaIspdomain);
    add("",plistaCondition);
    add("",plistaNaryop);
    add("",plistaIspop);
    add("",plistaBinaryrel);
    add("",plistaNaryrel);
    add("",cond);
    add("",fila);
    add("",plistaBvar);
    add("",plistaLogicopquotant);
    add("",plistaString);
    //Definicion de los componentes susceptibles a los eventos Action
    //------------------------------------------------------------------------------------
     listaContainer.addActionListener(this);
     listaApplybody.addActionListener(this);
     listaRelnbody.addActionListener(this);
     listaIspdomain.addActionListener(this);
     listaCondition.addActionListener(this);
     listaNaryop.addActionListener(this);
     listaIspop.addActionListener(this);
     listaBinaryrel.addActionListener(this);
     listaNaryrel.addActionListener(this);
     listaBvar.addActionListener(this);
     listaLogicopquotant.addActionListener(this); 
     listaString.addActionListener(this);
     ultimafila.addActionListener(this);;
     otrafila.addActionListener(this);
     especifcond.addActionListener(this);
     especifscond.addActionListener(this);
     ultimoarg.addActionListener(this);
     otroarg.addActionListener(this);
     ultimavar.addActionListener(this);
     otravar.addActionListener(this);
     //Definicion del Layout que tiene el dialogo matematico
     //setLayout(new CardLayout());
     ((CardLayout)this.getLayout()).first(this);
     setSize(350,200);
        
    };

public void actionPerformed(ActionEvent evento)
    {padre.actionPerformed(evento);
    };

    //-------------------------------------------------------------------------------------
    //Funcion privada que activa los elementos del emnu matematico en funcion de lo que hay en  la pila
    //-------------------------------------------------------------------------------------
public  void activamenumat(int noterminal)
    {
     switch(noterminal)
	 {case(1):((CardLayout)this.getLayout()).first(this);
                  
                 break;
	 case(2):((CardLayout)this.getLayout()).first(this);
                  ((CardLayout)this.getLayout()).next(this);
                  
                 break;
	 case(3):((CardLayout)this.getLayout()).first(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  
                 break;
	 case(4):((CardLayout)this.getLayout()).first(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  
                 break;
	 case(5):((CardLayout)this.getLayout()).first(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  
                 break;
	 case(6):((CardLayout)this.getLayout()).first(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  
                 break;
	 case(7):((CardLayout)this.getLayout()).first(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  
                 break;
	 case(8):((CardLayout)this.getLayout()).first(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this); 
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  
                break;
	 case(9):((CardLayout)this.getLayout()).first(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  
                 break;
	 case(10):((CardLayout)this.getLayout()).first(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  
                  break;
	 case(11):((CardLayout)this.getLayout()).first(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  
                  break;
	 case(12):((CardLayout)this.getLayout()).first(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  
                  break;
	 case(13):((CardLayout)this.getLayout()).first(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  
                  break;
	 case(14):((CardLayout)this.getLayout()).first(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  
                  break;
	 case(15):((CardLayout)this.getLayout()).first(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  
                  break;
	 case(16):((CardLayout)this.getLayout()).first(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  ((CardLayout)this.getLayout()).next(this);
                  
                  break;
         };
    };
    //-------------------------------------------------------------------------------------
    //Fin de la funcion que desactiva las opciones del menu matematico
    //-------------------------------------------------------------------------------------

};
//-----------------------------------------------------------------------------------------
//Fin de la clase que define el menu matematico
//-----------------------------------------------------------------------------------------

//-----------------------------------------------------------------------------------------
//Clase que implementa el menu de ayuda referencial matematico
//-----------------------------------------------------------------------------------------
class RefDialog extends Dialog implements ActionListener
{
 private MenuFrame padre;
 private Button cerrar;
 private TextArea texto;
 RefDialog(MenuFrame padre,String s,String button)
    {super(padre,s,false);
     setLayout(new FlowLayout());
     this.padre=padre;
     cerrar=new Button(button);
     add(cerrar);
     cerrar.addActionListener(this);
     texto =new TextArea(5,50);
     add(texto);
     cerrar.addActionListener(this);
     //setLayout(new FlowLayout());
     setSize(500,175);
     setResizable(false);
     texto.setEditable(false);
    };
public void actionPerformed(ActionEvent event)
    {padre.actionPerformed(event);
    };
public TextArea devuelveText()
    {return texto;};
public void setText(String s)
    {texto.setText(s);};
public void insertText(String s)
    {texto.insert(s,0);};
};
//-----------------------------------------------------------------------------------------
//Fin de la clase que implmenta el menu de ayuda referencial
//-----------------------------------------------------------------------------------------

//-----------------------------------------------------------------------------------------
//Clase que implementa el menu de cierre 
//-----------------------------------------------------------------------------------------
class CloseDialog extends Dialog implements ActionListener
{
 private MenuFrame padre;
 private Button cerrar;
 private Label aviso;
 CloseDialog(MenuFrame padre)
    {super(padre,"Ventana de aviso",false);
     setLayout(new FlowLayout());
     this.padre=padre;
     aviso=new Label("Si va a cerrar es hora de que corte y pegue el texto para guardarlo");
     cerrar=new Button("aceptar");
     cerrar.addActionListener(this);
     add(aviso);
     add(cerrar);
     cerrar.addActionListener(this);
     //setLayout(new FlowLayout());
     setSize(450,150);
     setResizable(false);
    };
public void actionPerformed(ActionEvent event)
    {padre.actionPerformed(event);
    };
};
//-----------------------------------------------------------------------------------------
//Fin de la clase que implmenta el menu de cierre
//-----------------------------------------------------------------------------------------


//-----------------------------------------------------------------------------------------
//Clase que implementa el menu de elegir tipo de letra 
//-----------------------------------------------------------------------------------------
class KeyDialog extends Dialog implements ActionListener
{
 private MenuFrame padre;
 private Label eti;
 private Button negrita;
 private Button normal;
 private Button salto;
 public KeyDialog(MenuFrame padre)
    {super(padre,"Ventana de eleccion",false);
     setLayout(new FlowLayout());
     this.padre=padre;
     eti =new Label("Elija tipo de letra");
     add(eti);
     normal=new Button("normal");
     negrita=new Button("negrita");
     salto=new Button("saltolinea");
     add(normal);
     add(negrita);
     add(salto);
     negrita.addActionListener(this);
     normal.addActionListener(this);
     salto.addActionListener(this);
     //setLayout(new FlowLayout());
     setSize(175,150);
     setResizable(false);
    };
public void actionPerformed(ActionEvent event)
    {padre.actionPerformed(event);
    };
};
//-----------------------------------------------------------------------------------------
//Fin de la clase que implmenta el menu de elegir el tipo de letra
//-----------------------------------------------------------------------------------------


//-----------------------------------------------------------------------------------------
//Clase que implementa el menu de elegir tipo de letra 
//-----------------------------------------------------------------------------------------
class KeyDialoga extends Dialog implements ActionListener
{
 private MenuFrame padre;
 private Label eti;
 private Button negrita;
 private Button cursiva;
 private Button subrayado;
 private Button parrafo;
 private Button salto;
 public KeyDialoga(MenuFrame padre)
    {super(padre,"Ventana de eleccion",false);
     setLayout(new FlowLayout());
     this.padre=padre;
     eti =new Label("Elija el shortcut");
     add(eti);
     cursiva=new Button("cursiva");
     negrita=new Button("negrita");
     subrayado=new Button("subrayado");
     parrafo=new Button("parrafo");
     salto=new Button("saltolinea");
     add(cursiva);
     add(negrita);
     add(salto);
     add(parrafo);
     add(subrayado);
     negrita.addActionListener(this);
     parrafo.addActionListener(this);
     salto.addActionListener(this);
     subrayado.addActionListener(this);
     cursiva.addActionListener(this);
     //setLayout(new FlowLayout());
     setSize(300,150);
     setResizable(false);
    };
public void actionPerformed(ActionEvent event)
    {padre.actionPerformed(event);
    };
};
//-----------------------------------------------------------------------------------------
//Fin de la clase que implmenta el menu de elegir el tipo de letra
//-----------------------------------------------------------------------------------------




//-----------------------------------------------------------------------------------------
//Clase que implementa el menu de entrada por teclado 
//-----------------------------------------------------------------------------------------
class KeyboardDialog extends Dialog implements ActionListener
{
 private MenuFrame padre;
 private Label eti;
 private Button introducir;
 private TextField texto;
 public KeyboardDialog(MenuFrame padre)
    {super(padre,"Ventana de eleccion",false);
     setLayout(new FlowLayout());
     this.padre=padre;
     eti =new Label("Introduzca texto en el campo");
     add(eti);
     introducir=new Button("introducir");
     texto=new TextField(20);
     introducir.addActionListener(this);
     add(texto);    
     add(introducir);
     introducir.addActionListener(this);
     //setLayout(new FlowLayout());
     setSize(300,150);
     setResizable(false);
    };
public void actionPerformed(ActionEvent event)
    {padre.actionPerformed(event);
    };
public String getText()
    {return texto.getText();
    };
public void setText(String s)
    {texto.setText(s);
    };
};
//-----------------------------------------------------------------------------------------
//Fin de la clase que implmenta el menu de entrada por teclado
//-----------------------------------------------------------------------------------------

//-----------------------------------------------------------------------------------------
//Clase que implementa el menu de entrada por teclado 
//-----------------------------------------------------------------------------------------
class KeyboardTextDialog extends Dialog implements ActionListener
{
 private MenuFrame padre;
 private Label eti;
 private Button introducir;
 private TextArea texto;
 public KeyboardTextDialog(MenuFrame padre)
    {super(padre,"Ventana de eleccion",false);
     setLayout(new FlowLayout());
     this.padre=padre;
     eti =new Label("Introduzca texto en el cuadro");
     add(eti);
     introducir=new Button("introducir");
     texto=new TextArea();
     introducir.addActionListener(this);
     add(texto);    
     add(introducir);
     introducir.addActionListener(this);
     //setLayout(new FlowLayout());
     setSize(640,250);
     setResizable(false);
    };
public void actionPerformed(ActionEvent event)
    {padre.actionPerformed(event);
    };
public String getText()
    {return texto.getText();
    };
public void setText(String s)
    {texto.setText(s);
    };
};
//-----------------------------------------------------------------------------------------
//Fin de la clase que implmenta el menu de entrada por teclado
//-----------------------------------------------------------------------------------------


//-----------------------------------------------------------------------------------------
//Clase que implementa el menu de ayuda 
//-----------------------------------------------------------------------------------------
class HelpDialog extends Dialog implements ActionListener
{
 private MenuFrame padre;
 private Label eti;
 private TextArea texto;
 public HelpDialog(MenuFrame padre)
    {super(padre,"Ventana de ayuda",false);
     setLayout(new FlowLayout());
     this.padre=padre;
     eti =new Label("Traduccion parcial");
     add(eti);
     texto=new TextArea();
     texto.setEditable(false);
     add(texto);    
     //setLayout(new FlowLayout());
     setSize(550,250);
     setResizable(false);
    };
public TextArea devuelveText()
    {return texto;};
public void actionPerformed(ActionEvent event)
    {padre.actionPerformed(event);
    };
public void setText(String texto)
    {this.texto.setText(texto);
    };
};
//-----------------------------------------------------------------------------------------
//Fin de la clase que implmenta el menu ayuda
//-----------------------------------------------------------------------------------------




//-----------------------------------------------------------------------------------------
//Clase que implementa el Frame del programa principal
//-----------------------------------------------------------------------------------------
class MenuFrame extends Frame implements ActionListener
{
 private edic app;
 private MenuBar menu;
 private Menu accion;
 private Menu edicion;
 private TextArea html;
 private MenuItem un;
 private MenuItem ua;
 private MenuItem in;
 private MenuItem t;
 private MenuItem nt;
 private MenuItem mat;
 private MenuItem ds;
 public MenuFrame(edic app)
    {super("Editor de MathMl para codigo de contenido");
     setLayout(new FlowLayout());
     this.app=app;
     menu=new MenuBar();
     setMenuBar(menu);
     accion =new Menu("Accion");
     un=new MenuItem("Usuario Normal");
     accion.add(un);
     ua=new MenuItem("Usuario Avanzado"); 
     accion.add(ua);
     in=new MenuItem("Inicio");
     accion.add(in);
     t=new MenuItem("Terminar");
     accion.add(t);
     menu.add(accion);
     edicion=new Menu("Edicion");
     nt =new MenuItem("Nuevo texto");
     edicion.add(nt);
     mat =new MenuItem("Matematicas");
     edicion.add(mat);
     ds =new MenuItem("Deshacer");
     edicion.add(ds);
     menu.add(edicion);
     html =new TextArea(30,100);
     html.setText("<HTML>\n<HEAD>\n</HEAD>\n<BODY>\n\n\n\n</BODY>\n</HTML>");
     html.setVisible(true);
     html.setEditable(false);
     add(html);
     //setLayout(new FlowLayout());
     accion.addActionListener(this);
     edicion.addActionListener(this);
     setResizable(false);
    };
 public TextArea devuelveArea()
    {return html;
     };
 public void setEnableUsuarioNormal(boolean b)
    {
     un.setEnabled(b);

    };
 public void setEnableUsuarioAvanzado(boolean b)
    {ua.setEnabled(b);
     
    };
 public void setEnableInicio(boolean b)
    {in.setEnabled(b);
     
    };
 public void setEnableTerminar(boolean b)
    {t.setEnabled(b);
   
    };
 public void setEnableNuevoTexto(boolean b)
    {nt.setEnabled(b);

     
    };
 public void setEnableMatematicas(boolean b)
    {
    mat.setEnabled(b);
    
    };
 public void setEnableDeshacer(boolean b)
    {ds.setEnabled(b);
    
    };
 public void setEditable(boolean b)
    {html.setEditable(b);
    };
 public int getCaretPosition()
    {return html.getCaretPosition();
    };
 public void setCaretPosition(int i)
    {html.setCaretPosition(i);
    };
 public void actionPerformed(ActionEvent evento)
    {app.actionPerformed(evento);
    };
 public boolean handleEvent(Event evento)
    {if(evento.id==Event.WINDOW_DESTROY)
	{//this.setVisible(false);
        this.dispose(); 
        return true ;
        };
     return super.handleEvent(evento);
    };
 public void setTextC(String s)
    {html.insert(s,html.getCaretPosition());
    };
 public void setText(String s)
    {html.setText(s);};
 public void insertText(String text,int position)
    {html.insert(text,position);
    };
 public int getIndex()
    {return html.getText().indexOf("</BODY>",1);
    };
 public String getText()
    {return html.getText();
    };
}



//*****************************************************************************************
//prog principal
//*****************************************************************************************

/**Definicion de la clase editor que es un applet*/

public class edic extends Applet implements ActionListener
{
    private boolean meteteclado;//variable boolenana que dice si se debe activar al opcion de string
    //Definicion de los datos del applet
    //-------------------------------------------------------------------------------------    
    // definicion de la pila utilizada en el algoritmo es una pila de objetos
    private Stack pila;
    private Stack basura;
    private Stack indices;
    private Stack referencias;
    private Stack referenciasaux;
    // definicion del nodo padre del arbol sintactico que se genera durante la ejecucion del programa
    //y de los nodos auxiliares que ayudan en al construccion de arbol sintactico
    private ArbolSintactico nodopadre;
    private ArbolSintactico nodoaux;
    private ArbolSintactico nodo1;
    private ArbolSintactico nodo2;
    private ArbolSintactico nodo3; 
    private ArbolSintactico nodo4;
    private ArbolSintactico nodo5; 
    private ArbolSintactico nodo6;
    private ArbolSintactico nodo7;
    private ArbolSintactico nodo8; 
    private ArbolSintactico nodo9;
    private ArbolSintactico nodo10;
    private ArbolSintactico nodo11;
    private ArbolSintactico nodo12;
    private ArbolSintactico nodo13;
    private ArbolSintactico nodo14;
    private ArbolSintactico nodo15;
    //Definicion del estado del programa
    private int estado;
    private int evento;
    private int evenaux;    
    private int ind;
    //Definicion del menu matematico
    DialogMat mat;
    RefDialog ref;
    //RefDialog trad;
    RefDialog help;
    KeyDialog key;
    KeyDialoga keya;
    CloseDialog cierre;
    KeyboardDialog keyboard;
    KeyboardTextDialog ktext;
    //HelpDialog help;
    HelpDialog trad;
    //definicion de los botones del menu principal
    MenuFrame menu;


    
    
    //-------------------------------------------------------------------------------------     
    //incializacion de la interfaz general de la aplicacion 
    //-------------------------------------------------------------------------------------

    //Este metodo es como un constructor del applet
    public void init()
    {
    //Iniciacion del menu principal
    menu=new MenuFrame(this);
    menu.setVisible(true);
    menu.setSize(menu.getPreferredSize());   

    //Iniciacion de los dialogos
    mat=new DialogMat(menu);
    //mat.setVisible(true);
    ref=new RefDialog(menu,"Menu de contexto","Deshacer");
    //ref.setVisible(true);
    help=new RefDialog(menu,"Ayuda de opciones","cerrar el entorno matematico");
    //trad.setVisible(true);
    cierre=new CloseDialog(menu);
    //cierre.setVisible(true);
    key =new KeyDialog(menu);
    //key.setVisible(true);
    keya=new KeyDialoga(menu);
    keyboard=new KeyboardDialog(menu);
    //keyboard.setVisible(true);
    ktext=new KeyboardTextDialog(menu);
    //ktext.setVisible(true);
    trad=new HelpDialog(menu);
    //help.setVisible(true);    
    };
    //-------------------------------------------------------------------------------------
    //Fin del metodo init
    //-------------------------------------------------------------------------------------





    //-------------------------------------------------------------------------------------
    //Incio  de Start, este metodo debe modelizar el estado inicial
    //-------------------------------------------------------------------------------------
    public void start()
     //este metodo debe implementar las condiciones de los componentes del estado inicial 1
         {
          
          //El estado inicial es el 1
          estado = 1;
          //El evento debe estar a cero
          evento=0;
          //La pila debe de estar vacia
          pila=new Stack();
          basura=new Stack();
          indices=new Stack();
          referencias=new Stack();
          referenciasaux =new Stack();
          //meteteclado se incializa a false
          meteteclado=false;
          limpia();
          menu.setEnableUsuarioNormal(true);
          menu.setEnableUsuarioAvanzado(true);
    
         };
    //-------------------------------------------------------------------------------------
    //Fin del metodo start
    //-------------------------------------------------------------------------------------

    public void stop()
       {
        mat.dispose();
        ref.dispose();
        trad.dispose();
        cierre.dispose();
        key.dispose();
        keya.dispose();
        keyboard.dispose();
        ktext.dispose();
        help.dispose();
        menu.dispose();
       };


    //-------------------------------------------------------------------------------------
    //Funcion privada que limpia los componenetes de la pantalla
    //-------------------------------------------------------------------------------------
    private void limpia()
      {
        mat.setVisible(false);;
        ref.setVisible(false);
        trad.setVisible(false);
        key.setVisible(false);
        keya.setVisible(false);
        cierre.setVisible(false);
        keyboard.setVisible(false);
        ktext.setVisible(false);
        help.setVisible(false);        
     menu.setEnableUsuarioNormal(false);
     menu.setEnableUsuarioAvanzado(false);
     menu.setEnableInicio(false);
     menu.setEnableTerminar(false);
     menu.setEnableNuevoTexto(false);
     menu.setEnableMatematicas(false);
     menu.setEnableDeshacer(false);
      

      };
    //-------------------------------------------------------------------------------------
    //Fin de la funcion que desactiva los elementos del menu
    //-------------------------------------------------------------------------------------





    
    //-------------------------------------------------------------------------------------
    //Funcion que devuelve lo que tiene el teclado en formato HTML
    //-------------------------------------------------------------------------------------

    private String tecladoFormat()
    {String aux=new String(ktext.getText());
     aux=aux+" \n";
     return aux;
    };


    private String tecladoFormatn()
    {String aux=new String("<B>");
     aux=aux+ktext.getText();
     aux=aux+"</B> \n";
     return aux;
    };
    //-------------------------------------------------------------------------------------
    //Fin funcion que formatea la entrada del teclado
    //-------------------------------------------------------------------------------------



    //-------------------------------------------------------------------------------------
    //-------------------------------------------------------------------------------------
 

    //-------------------------------------------------------------------------------------
    //Este metodo se encarga de manipular los eventos, se ha implementado la gestion de eventos nueva
    // haciendo que el applet implemente la interfaz ActionListener
    //Este metodo se implementa por medio de un automata finito determinista
    //La manera de hacer el reconocimiento del lenguaje es por medio de un automata a pilas
    //-------------------------------------------------------------------------------------
    
    public void actionPerformed (ActionEvent e)
    {String st =e.getActionCommand();
     switch(estado)
	 {case(1):if(st.equals("Usuario Normal"))
	          {estado=2;
                   limpia();
                   menu.setEnableTerminar(true);
                   menu.setEnableNuevoTexto(true);
                   menu.setEnableMatematicas(true);
                   menu.setEnableDeshacer(true);
                   menu.setEnableInicio(true);
                   menu.setEditable(false); 
                  };
                  if(st.equals("Usuario Avanzado"))
		  {estado=8;
                   limpia();
                   menu.setEnableInicio(true);
                   menu.setEnableTerminar(true);
                   menu.setEnableNuevoTexto(true);
                   menu.setEnableMatematicas(true);
                   menu.setEditable(true);
                  }; 
                  break;
         case(2):if(st.equals("Terminar"))
	         {limpia();
                  estado=6;
                  cierre.setVisible(true);
                 
                 };
                 if(st.equals("Deshacer"))
		 {if(!indices.empty())
                 menu.setText(menu.getText().substring(0,((Integer)indices.pop()).intValue())+"\n</BODY>\n</HTML>");
       
                 };
                 if(st.equals("Nuevo texto"))
		 {estado=3;
                  limpia();                 
                  key.setVisible(true);

                 };
                 if(st.equals("Matematicas"))
		 {estado=7;
                  limpia();
                  trad.setVisible(true);
                  help.setVisible(true);
                  ref.setVisible(true);
                  mat.setVisible(true);
                  mat.activamenumat(1);
                  help.setText("Elija la opcion que desee");
                  menu.setEnableDeshacer(true);
                  evento=1;
                  nodopadre=new ArbolSintactico(null,null,1,1,"Elija la opcion que desee",0);
                  pila.push(nodopadre);
                 
                 };
                 if(st.equals("Inicio"))
		 {estado=1;
                  limpia();
                  menu.setText("<HTML>\n<HEAD>\n</HEAD>\n<BODY>\n\n\n</BODY>\n</HTML>");
                  menu.setEnableUsuarioNormal(true);
                  menu.setEnableUsuarioAvanzado(true);
                  //vaciar la pila de indices
                  while(!indices.empty())
		      {indices.pop();};
                 };
                 break;
         case(3):if(st.equals("normal"))
	         {
                 estado=4;
                 limpia();
                 ktext.setVisible(true);
                 };
                 if(st.equals("negrita"))
		 {
                 estado=5;
                 limpia();
                 ktext.setVisible(true);
                 };
                 if(st.equals("saltolinea"))
		 {
                 estado=2;
                 limpia();
                 menu.setEnableInicio(true);
                 menu.setEnableTerminar(true);
                 menu.setEnableNuevoTexto(true);
                 menu.setEnableMatematicas(true);
                 menu.setEnableDeshacer(true);
                 indices.push(new Integer(menu.getIndex()));
                 menu.insertText("<BR>\n",menu.getIndex());
                
                 };
                 break;
         case(4):if(st.equals("introducir"))
                 {estado=2;
                 limpia();
                 menu.setEnableInicio(true);
                 menu.setEnableTerminar(true);
                 menu.setEnableNuevoTexto(true);
                 menu.setEnableMatematicas(true);
                 menu.setEnableDeshacer(true);
                 indices.push(new Integer(menu.getIndex()));
                 menu.insertText(tecladoFormat(),menu.getIndex());
                 ktext.setText("");
                 };
                 break;
         case(5):if(st.equals("introducir"))
                 {estado=2;
                 limpia();
                 menu.setEnableInicio(true);
                 menu.setEnableTerminar(true);
                 menu.setEnableNuevoTexto(true);
                 menu.setEnableMatematicas(true);
                 menu.setEnableDeshacer(true);
                 indices.push(new Integer(menu.getIndex()));
                 menu.insertText(tecladoFormatn(),menu.getIndex());
                 ktext.setText("");
                 };
                 break;
         case(6):if(st.equals("aceptar"))
                 {estado=2;
                 limpia();
                 menu.setEnableInicio(true);
                 menu.setEnableTerminar(true);
                 menu.setEnableNuevoTexto(true);
                 menu.setEnableMatematicas(true);
                 menu.setEnableDeshacer(true);
      
                 };
                 break;
 	 case(7):
         case(9):if(st.equals("cerrar el entorno matematico")||st.equals("Deshacer"))
	         {if(st.equals("Deshacer"))
		  {
                   if(!referencias.empty())
                   referencias.pop();
                  if(!basura.empty())
		  {if(pila.empty())
		   {//nodopadre=new ArbolSintactico(null,null,1,1,"",0);
		   ((ArbolSintactico)basura.peek()).estableceHijo(null);
                    pila.push(basura.pop());
                    mat.activamenumat(((ArbolSintactico)pila.peek()).token());
                   }
                   else
                   {
                   if(((ArbolSintactico)pila.peek()).devuelveEvento()==((ArbolSintactico)basura.peek()).devuelveEvento())
		   {((ArbolSintactico)basura.peek()).estableceHijo(null);
                    pila.push(basura.pop());
                    mat.activamenumat(((ArbolSintactico)pila.peek()).token());
                    help.setText(((ArbolSintactico)pila.peek()).devuelveInfo());
                    //evento--;
                   }
		   else
		   {//evento--;
                    if(((ArbolSintactico)pila.peek()).devuelveEvento()<((ArbolSintactico)basura.peek()).devuelveEvento())
		    {
                    ((ArbolSintactico)basura.peek()).estableceHijo(null);
                    pila.push(basura.pop());
                    mat.activamenumat(((ArbolSintactico)pila.peek()).token());
                    help.setText(((ArbolSintactico)pila.peek()).devuelveInfo());
                    }
                    else
		    {
                    evenaux=((ArbolSintactico) pila.pop()).devuelveEvento();
                    while((!pila.empty())&&(evenaux==((ArbolSintactico)pila.peek()).devuelveEvento()))
		    {pila.pop();
                    };
                    ((ArbolSintactico)basura.peek()).estableceHijo(null);
                    pila.push(basura.pop());
                    mat.activamenumat(((ArbolSintactico)pila.peek()).token());
                    help.setText(((ArbolSintactico)pila.peek()).devuelveInfo());
                    };
             
                   };
                  };
                  };
                  };
                  if(st.equals("cerrar el entorno matematico"))
		  {
                   while(!pila.empty())
		   {pila.pop();};
                   while(!referencias.empty())
		   {referencias.pop();};
                   if(estado==7)
			    {estado =2;
                             while(!basura.empty())
				 {basura.pop();};
                             limpia();
                             menu.setEnableInicio(true);
                             menu.setEnableTerminar(true);
                             menu.setEnableNuevoTexto(true);
                             menu.setEnableMatematicas(true);
                             menu.setEnableDeshacer(true);
                                                     
                            }
                        else
                        {estado=8;
                         while(!basura.empty())
			 {basura.pop();};
                          limpia();
                          menu.setEnableInicio(true);
                          menu.setEnableTerminar(true);
                          menu.setEnableNuevoTexto(true);
                          menu.setEnableMatematicas(true);
                        };
                  };
                  (Runtime.getRuntime()).gc();
                 }
                 else
		 {
                 if(meteteclado)
	         {if(st.equals("introducir"))
                  { meteteclado=false;
                   keyboard.setVisible(false);
                   menu.setEnableDeshacer(true);
                   nodoaux=(ArbolSintactico)pila.pop();
                   nodoaux.estableceSt(keyboard.getText());
                   nodoaux=(ArbolSintactico)pila.peek(); 
                   while(nodoaux.token()>16 &&!pila.empty())
		       {pila.pop();
                        if(!pila.empty())
                        nodoaux=(ArbolSintactico)pila.peek();
                       };           
                   if(pila.empty())
		       {//poner opciones de salida de estado
                         
                         if(estado==7)
			    {estado =2;
                             while(!basura.empty())
				 {basura.pop();};
                             while(!referencias.empty())
                                 {referencias.pop();};
                             limpia();
                             menu.setEnableInicio(true);
                             menu.setEnableTerminar(true);
                             menu.setEnableNuevoTexto(true);
                             menu.setEnableMatematicas(true);
                             menu.setEnableDeshacer(true);
                             indices.push(new Integer(menu.getIndex()));
                             nodopadre.escribe(menu.devuelveArea());                        
                            }
                        else
                        {estado=8;
                         while(!basura.empty())
			 {basura.pop();};
                         while(!referencias.empty())
			 {referencias.pop();};
                          limpia();
                          menu.setEnableInicio(true);
                          menu.setEnableTerminar(true);
                          menu.setEnableNuevoTexto(true);
                          menu.setEnableMatematicas(true);
                          nodopadre.escribea(menu.devuelveArea());
                        };
                        (Runtime.getRuntime()).gc();
		       }
                       
                   else
		       {//poner opciones de la cima de la pila
                       nodoaux=(ArbolSintactico)pila.peek();
                       mat.activamenumat(nodoaux.token());
                       help.setText(nodoaux.devuelveInfo());
                       };
                  };
                 }
                 else
                 {
                 //implementar el algoritmo de automata a pilas
	         if(pila.empty())
		     {//poner opciones de salida de estado
                      
                      if(estado==7)
			    {estado =2;
                             while(!basura.empty())
				 {basura.pop();};
                             while(!referencias.empty())
                                 {referencias.pop();};
                             limpia();
                             menu.setEnableInicio(true);
                             menu.setEnableTerminar(true);
                             menu.setEnableNuevoTexto(true);
                             menu.setEnableMatematicas(true);
                             menu.setEnableDeshacer(true);
                             indices.push(new Integer(menu.getIndex()));
                             nodopadre.escribe(menu.devuelveArea());
                            }
                        else
                        {estado=8;
                         while(!basura.empty())
			 {basura.pop();};
                         while(!referencias.empty())
			 {referencias.pop();};
                          limpia();
                          menu.setEnableInicio(true);
                          menu.setEnableTerminar(true);
                          menu.setEnableNuevoTexto(true);
                          menu.setEnableMatematicas(true);
                          nodopadre.escribea(menu.devuelveArea());
                        };
                     (Runtime.getRuntime()).gc();                   
                 }
                 else
                 {nodoaux=(ArbolSintactico)pila.peek();
                   if(!st.equals("introducir")&&!st.equals("definicion a traves de teclado"))
                   referencias.push(st+"\n");
                   switch(nodoaux.token())
		      {//deben ir las opciones de los eventos
                       case(1):if(st.equals("variable"))
			       {
                               nodo3=new ArbolSintactico(null,null,1,18,"",evento);
                               nodo3.estableceSt("</ci>");
                               nodo2=new ArbolSintactico(nodo3,null,1,16,"Elija una opcion para el nombre  de la variable",evento);
                               nodo1=new ArbolSintactico(nodo2,null,1,17,"",evento);
                               nodo1.estableceSt("<ci>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                               };
		               if(st.equals("variable con subindice"))
			       {
                               nodo10=new ArbolSintactico(null,null,2,18,"",evento);
                               nodo10.estableceSt("</ci>");
                               nodo9=new ArbolSintactico(nodo10,null,2,20,"",evento);
                               nodo9.estableceSt("</msub>");
			       nodo8=new ArbolSintactico(nodo9,null,2,22,"",evento);
                               nodo8.estableceSt("</mi>");
                               nodo7=new ArbolSintactico(nodo8,null,2,16,"Elija una opcion para el nombre del subindice",evento);
                               nodo6=new ArbolSintactico(nodo7,null,2,21,"",evento);
                               nodo6.estableceSt("<mi>");
                               nodo5=new ArbolSintactico(nodo6,null,2,22,"",evento);
                               nodo5.estableceSt("</mi>");
                               nodo4=new ArbolSintactico(nodo5,null,2,16,"Elija una opcion para el nombre de la variable",evento);
                               nodo3=new ArbolSintactico(nodo4,null,2,21,"",evento);
                               nodo3.estableceSt("<mi>");
                               nodo2=new ArbolSintactico(nodo3,null,2,19,"",evento);
                               nodo2.estableceSt("<msub>");
                               nodo1=new ArbolSintactico(nodo2,null,2,17,"",evento);
                               nodo1.estableceSt("<ci>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo10);
                               pila.push(nodo9);
                               pila.push(nodo8);
                               pila.push(nodo7);
                               pila.push(nodo6);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                               };
                               if(st.equals("variable con superindice"))
			       {
                               nodo10=new ArbolSintactico(null,null,3,18,"",evento);
                               nodo10.estableceSt("</ci>");
                               nodo9=new ArbolSintactico(nodo10,null,3,20,"",evento);
                               nodo9.estableceSt("</msub>");
			       nodo8=new ArbolSintactico(nodo9,null,3,22,"",evento);
                               nodo8.estableceSt("</mi>");
                               nodo7=new ArbolSintactico(nodo8,null,3,16,"Elija una opcion para el nombre del superindice",evento);
                               nodo6=new ArbolSintactico(nodo7,null,3,21,"",evento);
                               nodo6.estableceSt("<mi>");
                               nodo5=new ArbolSintactico(nodo6,null,3,22,"",evento);
                               nodo5.estableceSt("</mi>");
                               nodo4=new ArbolSintactico(nodo5,null,3,16,"Elija una opcion para el nombre de la variable",evento);
                               nodo3=new ArbolSintactico(nodo4,null,3,21,"",evento);
                               nodo3.estableceSt("<mi>");
                               nodo2=new ArbolSintactico(nodo3,null,3,19,"",evento);
                               nodo2.estableceSt("<msub>");
                               nodo1=new ArbolSintactico(nodo2,null,3,17,"",evento);
                               nodo1.estableceSt("<ci>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo10);
                               pila.push(nodo9);
                               pila.push(nodo8);
                               pila.push(nodo7);
                               pila.push(nodo6);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                               };
			       if(st.equals("numero real"))
                               {
                               nodo3=new ArbolSintactico(null,null,4,31,"",evento);
                               nodo3.estableceSt("</cn>");
                               nodo2=new ArbolSintactico(nodo3,null,4,16,"Elija una opcion, debe ser un numero real",evento);
                               nodo1=new ArbolSintactico(nodo2,null,4,25,"",evento);
                               nodo1.estableceSt("<cn type="+'"'+"real"+'"'+">");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                               };
			       if(st.equals("numero entero"))
                               {
                               nodo3=new ArbolSintactico(null,null,5,31,"",evento);
                               nodo3.estableceSt("</cn>");
                               nodo2=new ArbolSintactico(nodo3,null,5,16,"Elija una opcion, debe ser un numero entero",evento);
                               nodo1=new ArbolSintactico(nodo2,null,5,26,"",evento);
                               nodo1.estableceSt("<cn type="+'"'+"integer"+'"'+">");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                               };
			       if(st.equals("numero racional"))
                               {
                               nodo5=new ArbolSintactico(null,null,6,31,"",evento);
                               nodo5.estableceSt("</cn>");
                               nodo4=new ArbolSintactico(nodo5,null,6,16,"Elija una opcion para el denominador",evento);
                               nodo3=new ArbolSintactico(nodo4,null,6,32,"",evento);
                               nodo3.estableceSt("<sep/>");
                               nodo2=new ArbolSintactico(nodo3,null,6,16,"Elija una opcion para el numerador",evento);
                               nodo1=new ArbolSintactico(nodo2,null,6,27,"",evento);
                               nodo1.estableceSt("<cn type ="+'"'+"rational"+'"'+">");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                               };
			       if(st.equals("numero complejo cartesiano"))
                               {
                               nodo5=new ArbolSintactico(null,null,7,31,"",evento);
                               nodo5.estableceSt("</cn>");
                               nodo4=new ArbolSintactico(nodo5,null,7,16,"Elija una opcion la parte imaginaria",evento);
                               nodo3=new ArbolSintactico(nodo4,null,7,32,"",evento);
                               nodo3.estableceSt("<sep/>");
                               nodo2=new ArbolSintactico(nodo3,null,7,16,"Elija una opcion la parte real",evento);
                               nodo1=new ArbolSintactico(nodo2,null,7,28,"",evento);
                               nodo1.estableceSt("<cn type ="+'"'+"complex-cartesian"+'"'+">");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                               };
			       if(st.equals("numero  complejo polar"))
                               {
                               nodo5=new ArbolSintactico(null,null,8,31,"",evento);
                               nodo5.estableceSt("</cn>");
                               nodo4=new ArbolSintactico(nodo5,null,8,16,"Elija una opcion para el angulo",evento);
                               nodo3=new ArbolSintactico(nodo4,null,8,32,"",evento);
                               nodo3.estableceSt("<sep/>");
                               nodo2=new ArbolSintactico(nodo3,null,8,16,"Elija una opcion para el modulo",evento);
                               nodo1=new ArbolSintactico(nodo2,null,8,29,"",evento);
                               nodo1.estableceSt("<cn type ="+'"'+"complex-polar"+'"'+">");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                               };
			       if(st.equals("constante"))
                               {
                               nodo3=new ArbolSintactico(null,null,9,31,"",evento);
                               nodo3.estableceSt("</cn>");
                               nodo2=new ArbolSintactico(nodo3,null,9,16,"Elija una opcion para la constante",evento);
                               nodo1=new ArbolSintactico(nodo2,null,9,30,"",evento);
                               nodo1.estableceSt("<cn type ="+'"'+"constant"+'"'+">");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1); 
                               
                               };
			       if(st.equals("aplicacion de un operador o funcion a una lista de argumentos"))
                               {
                               nodo3=new ArbolSintactico(null,null,10,34,"",evento);
                               nodo3.estableceSt("</apply>");
                               nodo2=new ArbolSintactico(nodo3,null,10,2,"Elija el operador",evento);
                               nodo1=new ArbolSintactico(nodo2,null,10,33,"",evento);
                               nodo1.estableceSt("<apply>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                               };
			       if(st.equals("aplicacion de una relacion a una lista de argumentos"))
                               {
                               nodo3=new ArbolSintactico(null,null,11,36,"",evento);
                               nodo3.estableceSt("</reln>");
                               nodo2=new ArbolSintactico(nodo3,null,11,3,"Elija la relacion",evento);
                               nodo1=new ArbolSintactico(nodo2,null,11,35,"",evento);
                               nodo1.estableceSt("<reln>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                               };
			       if(st.equals("intervalo abierto-cerrado"))
			       {
                               nodo4=new ArbolSintactico(null,null,12,41,"",evento);
                               nodo4.estableceSt("</interval>");
                               nodo3=new ArbolSintactico(nodo4,null,12,1,"Elija una opcion para la parte derecha del intervalo",evento);
                               nodo2=new ArbolSintactico(nodo3,null,12,1,"Elija una opcion para la parte izquierda del intervalo",evento);
                               nodo1=new ArbolSintactico(nodo2,null,12,37,"",evento);
                               nodo1.estableceSt("<interval closure="+'"'+"open-closed"+"'"+">");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                               };
			       if(st.equals("intervalo abierto"))
                               {
                               nodo4=new ArbolSintactico(null,null,13,41,"",evento);
                               nodo4.estableceSt("</interval>");
                               nodo3=new ArbolSintactico(nodo4,null,13,1,"Elija una opcion para la parte derecha del intervalo",evento);
                               nodo2=new ArbolSintactico(nodo3,null,13,1,"Elija una opcion para la parte izquierda del intervalo",evento);
                               nodo1=new ArbolSintactico(nodo2,null,13,38,"",evento);
                               nodo1.estableceSt("<interval closure="+'"'+"open"+"'"+">");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                               };
			       if(st.equals("intervalo cerrado"))
                               {
                               nodo4=new ArbolSintactico(null,null,14,41,"",evento);
                               nodo4.estableceSt("</interval>");
                               nodo3=new ArbolSintactico(nodo4,null,14,1,"Elija una opcion para la parte derecha del intervalo",evento);
                               nodo2=new ArbolSintactico(nodo3,null,14,1,"Elija una opcion para la parte izquierda del intervalo",evento);
                               nodo1=new ArbolSintactico(nodo2,null,14,39,"",evento);
                               nodo1.estableceSt("<interval closure="+'"'+"closed"+"'"+">");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              
                               };
			       if(st.equals("intervalo cerrado abierto"))
                               {
                               nodo4=new ArbolSintactico(null,null,15,41,"",evento);
                               nodo4.estableceSt("</interval>");
                               nodo3=new ArbolSintactico(nodo4,null,15,1,"Elija una opcion para la parte derecha del intervalo",evento);
                               nodo2=new ArbolSintactico(nodo3,null,15,1,"Elija una opcion para la parte izquierda del intervalo",evento);
                               nodo1=new ArbolSintactico(nodo2,null,15,40,"",evento);
                               nodo1.estableceSt("<interval closure="+'"'+"closed-open"+"'"+">");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              
                               };
			       if(st.equals("lista"))
                               {
                               nodo3=new ArbolSintactico(null,null,16,43,"",evento);
                               nodo3.estableceSt("</list>");
                               nodo2=new ArbolSintactico(nodo3,null,16,12,"Elija especificar condicion o no",evento);
                               nodo1=new ArbolSintactico(nodo2,null,16,42,"",evento);
                               nodo1.estableceSt("<list>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                               };
			       if(st.equals("matriz"))
                               {
                               nodo3=new ArbolSintactico(null,null,17,45,"",evento);
                               nodo3.estableceSt("</matrix>");
                               nodo2=new ArbolSintactico(nodo3,null,17,13,"Elija si es la ultima fila u otra fila",evento);
                               nodo1=new ArbolSintactico(nodo2,null,17,44,"",evento);
                               nodo1.estableceSt("<matrix>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              
                               };
			       if(st.equals("conjunto"))
                               {
                               nodo3=new ArbolSintactico(null,null,18,47,"",evento);
                               nodo3.estableceSt("</set>");
                               nodo2=new ArbolSintactico(nodo3,null,18,12,"Elija espeficicar condicion o no",evento);
                               nodo1=new ArbolSintactico(nodo2,null,18,46,"",evento);
                               nodo1.estableceSt("<set>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1); 
                               
                               };
			       if(st.equals("vector"))
                               {
                               nodo3=new ArbolSintactico(null,null,19,49,"",evento);
                               nodo3.estableceSt("</vector>");
                               nodo2=new ArbolSintactico(nodo3,null,19,4,"Elija si es el ultimo elemento o es otro elemento",evento);
                               nodo1=new ArbolSintactico(nodo2,null,19,48,"",evento);
                               nodo1.estableceSt("<vector>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                               };
                               break;
		      case(2):if(st.equals("inversa"))
                              {
                               nodo2=new ArbolSintactico(null,null,20,1,"Elija el argumento para la inversa",evento);
                               nodo1=new ArbolSintactico(nodo2,null,20,50,"",evento);
                               nodo1.estableceSt("<inverse/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
		              if(st.equals("identidad"))
                              {
                               nodo2=new ArbolSintactico(null,null,21,1,"Elija el argumento para la identidad",evento);
                               nodo1=new ArbolSintactico(nodo2,null,21,51,"",evento);
                               nodo1.estableceSt("<ident/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("valor absoluto"))
                              {
                               nodo2=new ArbolSintactico(null,null,22,1,"Elija el argumento para el valor absoluto",evento);
                               nodo1=new ArbolSintactico(nodo2,null,22,52,"",evento);
                               nodo1.estableceSt("<abs/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("conjugado"))
                              {
                               nodo2=new ArbolSintactico(null,null,23,1,"Elija el argumento para el conjugado",evento);
                               nodo1=new ArbolSintactico(nodo2,null,23,53,"",evento);
                               nodo1.estableceSt("<conjugate/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("exponencial"))
                              {
                               nodo2=new ArbolSintactico(null,null,24,1,"Elija el argumento para la exponencial",evento);
                               nodo1=new ArbolSintactico(nodo2,null,24,54,"",evento);
                               nodo1.estableceSt("<exp/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              
                              };
			      if(st.equals("factorial"))
                              {
                               nodo2=new ArbolSintactico(null,null,25,1,"Elija el argumento para el factorial",evento);
                               nodo1=new ArbolSintactico(nodo2,null,25,55,"",evento);
                               nodo1.estableceSt("<factorial/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              
                              };
			      if(st.equals("menos unario"))
                              {
                               nodo2=new ArbolSintactico(null,null,26,1,"Elija el argumento para el menos unario",evento);
                               nodo1=new ArbolSintactico(nodo2,null,26,56,"",evento);
                               nodo1.estableceSt("<minus/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1); 
                               
                              };
			      if(st.equals("seno"))
                              {
                               nodo2=new ArbolSintactico(null,null,27,1,"Elija el argumento para el seno",evento);
                               nodo1=new ArbolSintactico(nodo2,null,27,57,"",evento);
                               nodo1.estableceSt("<sin/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("coseno"))
                              {
                               nodo2=new ArbolSintactico(null,null,28,1,"Elija el argumento para el coseno",evento);
                               nodo1=new ArbolSintactico(nodo2,null,28,58,"",evento);
                               nodo1.estableceSt("<cos/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("tangente"))
                              {
                               nodo2=new ArbolSintactico(null,null,29,1,"Elija el argumento para la tangente",evento);
                               nodo1=new ArbolSintactico(nodo2,null,29,59,"",evento);
                               nodo1.estableceSt("<tan/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("secante"))
                              {
                               nodo2=new ArbolSintactico(null,null,30,1,"Elija el argumento para la secante",evento);
                               nodo1=new ArbolSintactico(nodo2,null,30,60,"",evento);
                               nodo1.estableceSt("<sec/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("cosecante"))
                              {
                               nodo2=new ArbolSintactico(null,null,31,1,"Elija el argumento para la cosecante",evento);
                               nodo1=new ArbolSintactico(nodo2,null,31,61,"",evento);
                               nodo1.estableceSt("<csc/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("cotangente"))
                              {
                               nodo2=new ArbolSintactico(null,null,32,1,"Elija el argumento para la cotangente",evento);
                               nodo1=new ArbolSintactico(nodo2,null,32,62,"",evento);
                               nodo1.estableceSt("<cot/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("seno hiperbolico"))
                              {
                               nodo2=new ArbolSintactico(null,null,33,1,"Elija el argumento para el seno hiperbolico",evento);
                               nodo1=new ArbolSintactico(nodo2,null,33,63,"",evento);
                               nodo1.estableceSt("<sinh/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("coseno hiperbolico"))
                              {
                               nodo2=new ArbolSintactico(null,null,34,1,"Elija el argumento para el coseno hiperbolico",evento);
                               nodo1=new ArbolSintactico(nodo2,null,34,64,"",evento);
                               nodo1.estableceSt("<cosh/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("tangente hiperbolica"))
                              {
                               nodo2=new ArbolSintactico(null,null,35,1,"Elija el argumento para la tangente hiperbolica",evento);
                               nodo1=new ArbolSintactico(nodo2,null,35,65,"",evento);
                               nodo1.estableceSt("<tanh/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("secante hiperbolica"))
                              {
                               nodo2=new ArbolSintactico(null,null,36,1,"Elija el argumento para la secante hiperbolica",evento);
                               nodo1=new ArbolSintactico(nodo2,null,36,66,"",evento);
                               nodo1.estableceSt("<sech/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("cosecante hiperbolica"))
                              {
                               nodo2=new ArbolSintactico(null,null,37,1,"Elija el argumento para la cosecante hiperbolica",evento);
                               nodo1=new ArbolSintactico(nodo2,null,37,67,"",evento);
                               nodo1.estableceSt("<csch/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                           
                              };
			      if(st.equals("cotangente hiperbolica"))
                              {
                               nodo2=new ArbolSintactico(null,null,38,1,"Elija el argumento para la cotangente hiperbolica",evento);
                               nodo1=new ArbolSintactico(nodo2,null,38,68,"",evento);
                               nodo1.estableceSt("<coth/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              }; 
			      if(st.equals("arcoseno"))
                              {
                               nodo2=new ArbolSintactico(null,null,39,1,"Elija el argumento para el arco seno",evento);
                               nodo1=new ArbolSintactico(nodo2,null,39,69,"",evento);
                               nodo1.estableceSt("<arcsin/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("arcocoseno"))
                              {
                               nodo2=new ArbolSintactico(null,null,40,1,"Elija el argumento para el arco coseno",evento);
                               nodo1=new ArbolSintactico(nodo2,null,40,70,"",evento);
                               nodo1.estableceSt("<arccos/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("arcotangente"))
                              {
                               nodo2=new ArbolSintactico(null,null,41,1,"Elija el argumento para el arco tangente",evento);
                               nodo1=new ArbolSintactico(nodo2,null,41,71,"",evento);
                               nodo1.estableceSt("<arctan/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("determinante"))
                              {
                               nodo2=new ArbolSintactico(null,null,42,1,"Elija el argumento para el determinante",evento);
                               nodo1=new ArbolSintactico(nodo2,null,42,72,"",evento);
                               nodo1.estableceSt("<determinant/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("transpuesta"))
                              {
                               nodo2=new ArbolSintactico(null,null,43,1,"Elija el argumento para la transpuesta",evento);
                               nodo1=new ArbolSintactico(nodo2,null,43,73,"",evento);
                               nodo1.estableceSt("<tranpose/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("logaritmo neperiano"))
                              {
                               nodo2=new ArbolSintactico(null,null,44,1,"Elija el argumento para el logaritmo neperiano",evento);
                               nodo1=new ArbolSintactico(nodo2,null,44,74,"",evento);
                               nodo1.estableceSt("<ln/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("negacion logica"))
                              {
                               nodo2=new ArbolSintactico(null,null,45,1,"Elija el argumento para la negacion logica",evento);
                               nodo1=new ArbolSintactico(nodo2,null,45,75,"",evento);
                               nodo1.estableceSt("<not/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("cociente"))
                              {
                               nodo3=new ArbolSintactico(null,null,46,1,"Elija opciones para el divisor en el calculo del cociente",evento);
                               nodo2=new ArbolSintactico(nodo3,null,46,1,"Elija opciones para el dividendo en el calculo del cociente",evento);
                               nodo1=new ArbolSintactico(nodo2,null,46,76,"",evento);
                               nodo1.estableceSt("<quotient/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              
                              };
			      if(st.equals("division"))
                              {
                               nodo3=new ArbolSintactico(null,null,47,1,"Elija opciones para el divisor en el calculo de la division",evento);
                               nodo2=new ArbolSintactico(nodo3,null,47,1,"Elija opciones para el dividendo en el calculo de la division",evento);
                               nodo1=new ArbolSintactico(nodo2,null,47,77,"",evento);
                               nodo1.estableceSt("<divide/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("menos binario"))
                              {
                               nodo3=new ArbolSintactico(null,null,48,1,"Elija opciones para la parte derecha de la resta",evento);
                               nodo2=new ArbolSintactico(nodo3,null,48,1,"Elija opciones para la parte izquierda de la resta",evento);
                               nodo1=new ArbolSintactico(nodo2,null,48,56,"",evento);
                               nodo1.estableceSt("<minus/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              
                              };
			      if(st.equals("potencia"))
                              {
                               nodo3=new ArbolSintactico(null,null,49,1,"Elija opciones para el exponente",evento);
                               nodo2=new ArbolSintactico(nodo3,null,49,1,"Elija opciones para la base",evento);
                               nodo1=new ArbolSintactico(nodo2,null,49,78,"",evento);
                               nodo1.estableceSt("<power/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("resto de division"))
                              {
                               nodo3=new ArbolSintactico(null,null,50,1,"Elija opciones para el divisor en el calculo del resto",evento);
                               nodo2=new ArbolSintactico(nodo3,null,50,1,"Elija opciones para el dividendo en el calculo del resto",evento);
                               nodo1=new ArbolSintactico(nodo2,null,50,79,"",evento);
                               nodo1.estableceSt("<rem/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("diferencia de conjuntos"))
                              {
                               nodo3=new ArbolSintactico(null,null,51,1,"Elija opciones para el conjunto de la parte derecha",evento);
                               nodo2=new ArbolSintactico(nodo3,null,51,1,"Elija opciones para el conjunto de la parte izquierda",evento);
                               nodo1=new ArbolSintactico(nodo2,null,51,80,"",evento);
                               nodo1.estableceSt("<setdiff/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                             
                              };
			      if(st.equals("implicacion logica"))
                              {
                               nodo3=new ArbolSintactico(null,null,52,1,"Elija opciones para la parte derecha de la implicacion",evento);
                               nodo2=new ArbolSintactico(nodo3,null,52,1,"Elija opciones para la parte izquierda de la implicacion",evento);
                               nodo1=new ArbolSintactico(nodo2,null,52,81,"",evento);
                               nodo1.estableceSt("<implies/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              }; 
			      if(st.equals("operador o funcion  n-ario"))
                              {
                               nodo2=new ArbolSintactico(null,null,53,4,"Elija si quiere un argumento o varios",evento);
                               nodo1=new ArbolSintactico(nodo2,null,53,8,"Elija la opcion que desee",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("operador o funcion n-ario especificando condicion"))
                              {
                               nodo4=new ArbolSintactico(null,null,54,1,"Elija opciones para el argumento",evento);
                               nodo3=new ArbolSintactico(nodo4,null,54,7,"Elija opciones para la condicion",evento);
                               nodo2=new ArbolSintactico(nodo3,null,54,5,"Elija opciones si quiere especificar una variable o varias",evento);
                               nodo1=new ArbolSintactico(nodo2,null,54,8,"Elija la opcion que desee",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("sumatorio, producto o integral especificando dominio y variable"))
                              {
                               nodo4=new ArbolSintactico(null,null,55,1,"Elija opciones para el cuerpo del sumatorio producto o integral",evento);
                               nodo3=new ArbolSintactico(nodo4,null,55,6,"Elija opciones para el dominio",evento);
                               nodo2=new ArbolSintactico(nodo3,null,55,14,"Elija opciones para  especificar la  variable",evento);
                               nodo1=new ArbolSintactico(nodo2,null,55,9,"Elija la opcion de sumatorio producto o integral que desee",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
			      if(st.equals("sumatorio, producto o integral especificando dominio"))
                              {
                               nodo3=new ArbolSintactico(null,null,56,1,"Elija opciones para el cuerpo del sumatorio producto o integral",evento);
                               nodo2=new ArbolSintactico(nodo3,null,56,14,"Elija opciones para  especificar la  variable",evento);
                               nodo1=new ArbolSintactico(nodo2,null,56,9,"Elija la opcion de sumatorio producto o integral que desee",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
			      if(st.equals("sumatorio, producto o integral especificando variable"))
                              {
                               nodo3=new ArbolSintactico(null,null,57,1,"Elija opciones para el cuerpo del sumatorio producto o integral",evento);
                               nodo2=new ArbolSintactico(nodo3,null,57,6,"Elija opciones para el dominio",evento);
                               nodo1=new ArbolSintactico(nodo2,null,57,9,"Elija la opcion de sumatorio producto o integral que desee",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
			      if(st.equals("sumatorio, producto o integral sin especificaciones"))
                              {
                               nodo2=new ArbolSintactico(null,null,58,1,"Elija opciones para el cuerpo del sumatorio producto o integral",evento);
                               nodo1=new ArbolSintactico(nodo2,null,58,9,"Elija la opcion de sumatorio producto o integral que desee",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
			      if(st.equals("derivada sobre funcion de una sola variable"))
                              {
                               nodo3=new ArbolSintactico(null,null,59,1,"Elija opciones para el cuerpo de la derivada",evento);
                               nodo2=new ArbolSintactico(nodo3,null,59,14,"Elija opciones para  especificar la  variable",evento);
                               nodo1=new ArbolSintactico(nodo2,null,59,82,"",evento);
                               nodo1.estableceSt("<diff/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("derivada parcial"))
                              {
                               nodo3=new ArbolSintactico(null,null,60,1,"Elija opciones para el cuerpo de la derivada parcial",evento);
                               nodo2=new ArbolSintactico(nodo3,null,60,5,"Elija opciones para  especificar si quiere una variable o varias",evento);
                               nodo1=new ArbolSintactico(nodo2,null,60,83,"",evento);
                               nodo1.estableceSt("<partialdiff/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("logaritmo especificando base"))
                              {
                               nodo5=new ArbolSintactico(null,null,61,1,"Elija la opcion que desee para el cuerpo del logaritmo",evento);
                               nodo4=new ArbolSintactico(nodo5,null,61,86,"",evento);
                               nodo4.estableceSt("</logbase>");
                               nodo3=new ArbolSintactico(nodo4,null,61,1,"Elija la opcion que quiera para la base del logaritmo",evento);
                               nodo2=new ArbolSintactico(nodo3,null,61,85,"",evento);
                               nodo2.estableceSt("<logbase>");
                               nodo1=new ArbolSintactico(nodo2,null,61,84,"",evento);
                               nodo1.estableceSt("<log/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("logaritmo base 10"))
                              {
                               nodo2=new ArbolSintactico(null,null,62,1,"Elija opcion para el cuerpo del logaritmo en base 10",evento);
                               nodo1=new ArbolSintactico(nodo2,null,62,84,"",evento);
                               nodo1.estableceSt("<log/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("momento estadistico especificando orden"))
                              {
                               nodo5=new ArbolSintactico(null,null,63,4,"Elija la opcion entre ultimo argumento u otro argumento para el momento",evento);
                               nodo4=new ArbolSintactico(nodo5,null,63,89,"",evento);
                               nodo4.estableceSt("</degree>");
                               nodo3=new ArbolSintactico(nodo4,null,63,1,"Elija la opcion que quiera para especificar el orden del momento",evento);
                               nodo2=new ArbolSintactico(nodo3,null,63,88,"",evento);
                               nodo2.estableceSt("<degree>");
                               nodo1=new ArbolSintactico(nodo2,null,63,87,"",evento);
                               nodo1.estableceSt("<moment/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              
                              };
			      if(st.equals("momento estadistico orden 1"))
                              {
                               
                               nodo2=new ArbolSintactico(null,null,64,4,"Elija la opcion entre ultimo argumento u otro argumento para el momento",evento);
                               nodo1=new ArbolSintactico(nodo2,null,64,87,"",evento);
                               nodo1.estableceSt("<moment/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("raiz especificando grado"))
                              {
                               nodo5=new ArbolSintactico(null,null,65,1,"Elija la opcion que desee para el cuerpo de la raiz",evento);
                               nodo4=new ArbolSintactico(nodo5,null,65,89,"",evento);
                               nodo4.estableceSt("</degree>");
                               nodo3=new ArbolSintactico(nodo4,null,65,1,"Elija la opcion que quiera para especificar el grado de la raiz",evento);
                               nodo2=new ArbolSintactico(nodo3,null,65,88,"",evento);
                               nodo2.estableceSt("<degree>");
                               nodo1=new ArbolSintactico(nodo2,null,65,90,"",evento);
                               nodo1.estableceSt("<root/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              
                              };
			      if(st.equals("raiz cuadrada"))
                              {
                               nodo2=new ArbolSintactico(null,null,66,1,"Elija opcion para el cuerpo de la raiz cuadrada",evento);
                               nodo1=new ArbolSintactico(nodo2,null,66,90,"",evento);
                               nodo1.estableceSt("<root/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              }; 
			      if(st.equals("limite"))
                              {
                               nodo6=new ArbolSintactico(null,null,67,1,"Elija una opcion para el cuerpo del limite",evento);
                               nodo5=new ArbolSintactico(nodo6,null,67,93,"",evento);
                               nodo5.estableceSt("</lowlimit>");
                               nodo4=new ArbolSintactico(nodo5,null,67,1,"Elija una opcion para donde tiende el limite",evento);
                               nodo3=new ArbolSintactico(nodo4,null,67,92,"",evento);
                               nodo3.estableceSt("<lowlimit>");
                               nodo2=new ArbolSintactico(nodo3,null,67,5,"Elija entre especificar una variable o varias para el limite",evento);
                               nodo1=new ArbolSintactico(nodo2,null,67,91,"",evento);
                               nodo1.estableceSt("<limit/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo6);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               
                              };
			      if(st.equals("limite con condicion"))
                              {
                               nodo4=new ArbolSintactico(null,null,68,1,"Elija una opcion para el cuerpo del limite",evento);
                               nodo3=new ArbolSintactico(nodo4,null,68,7,"Elija una opcion para la condicion del limite",evento);
                               nodo2=new ArbolSintactico(nodo3,null,68,5,"Elija entre especificar una variable o varias para el limite",evento);
                               nodo1=new ArbolSintactico(nodo2,null,68,91,"",evento);
                               nodo1.estableceSt("<limit/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              
                              };
			      if(st.equals("cuantificador logico con condicion aplicado a operador o funcion con lista de argumentos"))
                              {
                               nodo8=new ArbolSintactico(null,null,69,95,"",evento);
                               nodo8.estableceSt(")");
                               nodo7=new ArbolSintactico(nodo8,null,69,34,"",evento);
                               nodo7.estableceSt("</apply>");
                               nodo6=new ArbolSintactico(nodo7,null,69,2,"Elija una opcion para el operador",evento);
                               nodo5=new ArbolSintactico(nodo6,null,69,33,"",evento);
                               nodo5.estableceSt("<apply>");
                               nodo4=new ArbolSintactico(nodo5,null,69,94,"",evento);
                               nodo4.estableceSt("(");
                               nodo3=new ArbolSintactico(nodo4,null,69,7,"Elija la opcion que desee para la condicion",evento);
                               nodo2=new ArbolSintactico(nodo3,null,69,5,"Elija entre especificar una variable o varias para la expresion cuantificada",evento);
                               nodo1=new ArbolSintactico(nodo2,null,69,15,"Elija el cuantificador logico que desee",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo8);
                               pila.push(nodo7);
                               pila.push(nodo6);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
			      if(st.equals("cuantificador logico con condicion aplicado a relacion con lista de argumentos"))
                              {
                               nodo8=new ArbolSintactico(null,null,70,95,"",evento);
                               nodo8.estableceSt(")");
                               nodo7=new ArbolSintactico(nodo8,null,70,36,"",evento);
                               nodo7.estableceSt("</reln>");
                               nodo6=new ArbolSintactico(nodo7,null,70,3,"Elija una opcion para el operador",evento);
                               nodo5=new ArbolSintactico(nodo6,null,70,35,"",evento);
                               nodo5.estableceSt("<reln>");
                               nodo4=new ArbolSintactico(nodo5,null,70,94,"",evento);
                               nodo4.estableceSt("(");
                               nodo3=new ArbolSintactico(nodo4,null,70,7,"Elija la opcion que desee para la condicion",evento);
                               nodo2=new ArbolSintactico(nodo3,null,70,5,"Elija entre especificar una variable o varias para la expresion cuantificada",evento);
                               nodo1=new ArbolSintactico(nodo2,null,70,15,"Elija el cuantificador logico que desee",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo8);
                               pila.push(nodo7);
                               pila.push(nodo6);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
			      if(st.equals("cuantificador logico aplicado a operador con lista de argumentos"))
                              {
                               nodo7=new ArbolSintactico(null,null,71,95,"",evento);
                               nodo7.estableceSt(")");
                               nodo6=new ArbolSintactico(nodo7,null,71,34,"",evento);
                               nodo6.estableceSt("</apply>");
                               nodo5=new ArbolSintactico(nodo6,null,71,2,"Elija una opcion para el operador",evento);
                               nodo4=new ArbolSintactico(nodo5,null,71,33,"",evento);
                               nodo4.estableceSt("<apply>");
                               nodo3=new ArbolSintactico(nodo4,null,71,94,"",evento);
                               nodo3.estableceSt("(");
                               nodo2=new ArbolSintactico(nodo3,null,71,5,"Elija entre especificar una variable o varias para la expresion cuantificada",evento);
                               nodo1=new ArbolSintactico(nodo2,null,71,15,"Elija el cuantificador logico que desee",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo7);
                               pila.push(nodo6);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
			      if(st.equals("cuantificador logico aplicado a relacion con lista de argumentos"))
                              {
                               nodo7=new ArbolSintactico(null,null,72,95,"",evento);
                               nodo7.estableceSt(")");
                               nodo6=new ArbolSintactico(nodo7,null,72,36,"",evento );
                               nodo6.estableceSt("</reln>");
                               nodo5=new ArbolSintactico(nodo6,null,72,3,"Elija una opcion para el operador",evento);
                               nodo4=new ArbolSintactico(nodo5,null,72,35,"",evento);
                               nodo4.estableceSt("<reln>");
                               nodo3=new ArbolSintactico(nodo4,null,72,94,"",evento);
                               nodo3.estableceSt("(");
                               nodo2=new ArbolSintactico(nodo3,null,72,5,"Elija entre especificar una variable o varias para la expresion cuantificada",evento);
                               nodo1=new ArbolSintactico(nodo2,null,72,15,"Elija el cuantificador logico que desee",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo7);
                               pila.push(nodo6);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
                              break;
   		       case(3):if(st.equals("relacion binaria con condicion"))
                              {
                               nodo5=new ArbolSintactico(null,null,73,1,"Elija la opcion que desee para la parte derecha de la relacion binaria",evento);
                               nodo4=new ArbolSintactico(nodo5,null,73,1,"Elija la opcion que desee para la parte izquierda de la relacion binaria",evento);
                               nodo3=new ArbolSintactico(nodo4,null,73,7,"Elija la opcion que quiera para especificar la condicion",evento);
                               nodo2=new ArbolSintactico(nodo3,null,73,5,"Elija entre especificar una variable o mas",evento);
                               nodo1=new ArbolSintactico(nodo2,null,73,10,"Elija la relacion binaria que desee",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
		              if(st.equals("relacion n-aria con condicion"))
                              {
                               nodo4=new ArbolSintactico(null,null,74,4,"Elija la opcion entre especificar un argumento o varios",evento);
                               nodo3=new ArbolSintactico(nodo4,null,74,7,"Elija la opcion que quiera para especificar la condicion",evento);
                               nodo2=new ArbolSintactico(nodo3,null,74,5,"Elija entre especificar una variable o mas",evento);
                               nodo1=new ArbolSintactico(nodo2,null,74,11,"Elija la relacion naria que desee",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
			      if(st.equals("relacion binaria"))
                              {
                               nodo3=new ArbolSintactico(null,null,75,1,"Elija la opcion que desee para la parte derecha de la relacion binaria",evento);
                               nodo2=new ArbolSintactico(nodo3,null,75,1,"Elija la opcion que desee para la parte izquierda de la relacion binaria",evento);
                               nodo1=new ArbolSintactico(nodo2,null,75,10,"Elija la relacion binaria que desee",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
			      if(st.equals("relacion n-aria"))
                              {
                               nodo2=new ArbolSintactico(null,null,76,4,"Elija la opcion entre especificar un argumento o varios",evento);
                               nodo1=new ArbolSintactico(nodo2,null,76,11,"Elija la relacion naria que desee",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
                              break;
		       case(4):if(st.equals ("ultimo argumento"))
			       {
                               nodo1=new ArbolSintactico(null,null,77,1,"Elija la opcion que desee para el argumento",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1); 
                               };
                               if(st.equals("otro argumento"))
			       {
                               nodo2=new ArbolSintactico(null,null,78,4,"Elija la opcion entre especificar un argumento o varios",evento);
                               nodo1=new ArbolSintactico(nodo2,null,78,1,"Elija la opcion que desee para el argumento",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               };
                               break;
		       case(5):if(st.equals ("ultima variable"))
			       {
                               nodo1=new ArbolSintactico(null,null,79,14,"Elija la opcion que desee para la variable",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
		               if(st.equals("otra variable"))
                               {
                               nodo2=new ArbolSintactico(null,null,80,5,"Elija la opcion entre especificar una variable o varias",evento);
                               nodo1=new ArbolSintactico(nodo2,null,80,14,"Elija la opcion que desee para la variable",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               };
                               break;
		      case(6):if(st.equals("especificar limite superior e inferior"))
                              {
                               nodo6=new ArbolSintactico(null,null,81,97,"",evento);
                               nodo6.estableceSt("</uplimit>");
                               nodo5=new ArbolSintactico(nodo6,null,81,1,"Elija una opcion para el limite superior",evento);
                               nodo4=new ArbolSintactico(nodo5,null,81,96,"",evento);
                               nodo4.estableceSt("<uplimit>");
                               nodo3=new ArbolSintactico(nodo4,null,81,93,"",evento);
                               nodo3.estableceSt("</lowlimit>");
                               nodo2=new ArbolSintactico(nodo3,null,81,1,"Elija una opcion para a el limite inferior",evento);
                               nodo1=new ArbolSintactico(nodo2,null,81,92,"",evento);
                               nodo1.estableceSt("<lowlimit/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo6);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
		              if(st.equals("especificar limite inferior"))
                              {
                               nodo3=new ArbolSintactico(null,null,82,93,"",evento);
                               nodo3.estableceSt("</lowlimit>");
                               nodo2=new ArbolSintactico(nodo3,null,82,1,"Elija una opcion para a el limite inferior",evento);
                               nodo1=new ArbolSintactico(nodo2,null,82,92,"",evento);
                               nodo1.estableceSt("<lowlimit/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              }; 
			      if(st.equals("especificar limite superior"))
                              {
                               nodo3=new ArbolSintactico(null,null,83,97,"",evento);
                               nodo3.estableceSt("</uplimit>");
                               nodo2=new ArbolSintactico(nodo3,null,83,1,"Elija una opcion para el limite superior",evento);
                               nodo1=new ArbolSintactico(nodo2,null,83,96,"",evento);
                               nodo1.estableceSt("<uplimit>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
			      if(st.equals("especificar intervalo abierto-cerrado"))
                              {
                               nodo4=new ArbolSintactico(null,null,84,41,"",evento);
                               nodo4.estableceSt("</interval>");
                               nodo3=new ArbolSintactico(nodo4,null,84,1,"Elija una opcion para la parte derecha del intervalo",evento);
                               nodo2=new ArbolSintactico(nodo3,null,84,1,"Elija una opcion para la parte izquierda del intervalo",evento);
                               nodo1=new ArbolSintactico(nodo2,null,84,37,"",evento);
                               nodo1.estableceSt("<interval closure="+'"'+"open-closed"+"'"+">");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
			      if(st.equals("especificar intervalo abierto"))
                              {
                               nodo4=new ArbolSintactico(null,null,85,41,"",evento);
                               nodo4.estableceSt("</interval>");
                               nodo3=new ArbolSintactico(nodo4,null,85,1,"Elija una opcion para la parte derecha del intervalo",evento);
                               nodo2=new ArbolSintactico(nodo3,null,85,1,"Elija una opcion para la parte izquierda del intervalo",evento);
                               nodo1=new ArbolSintactico(nodo2,null,85,38,"",evento);
                               nodo1.estableceSt("<interval closure="+'"'+"open"+"'"+">");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
			      if(st.equals("especificar intervalo cerrado"))
                              {
                               nodo4=new ArbolSintactico(null,null,86,41,"",evento);
                               nodo4.estableceSt("</interval>");
                               nodo3=new ArbolSintactico(nodo4,null,86,1,"Elija una opcion para la parte derecha del intervalo",evento);
                               nodo2=new ArbolSintactico(nodo3,null,86,1,"Elija una opcion para la parte izquierda del intervalo",evento);
                               nodo1=new ArbolSintactico(nodo2,null,86,39,"",evento);
                               nodo1.estableceSt("<interval closure="+'"'+"closed"+"'"+">");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
			      if(st.equals("especificar intervalo cerrado-abierto"))
                              {
                               nodo4=new ArbolSintactico(null,null,87,41,"",evento);
                               nodo4.estableceSt("</interval>");
                               nodo3=new ArbolSintactico(nodo4,null,87,1,"Elija una opcion para la parte derecha del intervalo",evento);
                               nodo2=new ArbolSintactico(nodo3,null,87,1,"Elija una opcion para la parte izquierda del intervalo",evento);
                               nodo1=new ArbolSintactico(nodo2,null,87,40,"",evento);
                               nodo1.estableceSt("<interval closure="+'"'+"closed-open"+"'"+">");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
			      if(st.equals("especificar condicion"))
                              {
                               nodo1=new ArbolSintactico(nodo2,null,88,7,"Elija la opcion que desee para la condicion",evento);
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                              };
                              break;
		      case(7):if(st.equals("especificar condicion con relacion aplicada a una lista de argumentos"))
                              
                              {
                               nodo5=new ArbolSintactico(null,null,89,99,"",evento);
                               nodo5.estableceSt("</condition>");
                               nodo4=new ArbolSintactico(nodo5,null,89,36,"",evento);
                               nodo4.estableceSt("</reln>");
                               nodo3=new ArbolSintactico(nodo4,null,89,3,"Elija la opcion que quiera para la relacion",evento);
                               nodo2=new ArbolSintactico(nodo3,null,89,35,"",evento);
                               nodo2.estableceSt("<reln>");
                               nodo1=new ArbolSintactico(nodo2,null,89,98,"",evento);
                               nodo1.estableceSt("<condition>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
                              if(st.equals("especificar condicion con operador o funcion aplicado a una lista de argumentos"))
		              
                              {
                               nodo5=new ArbolSintactico(null,null,90,99,"",evento);
                               nodo5.estableceSt("</condition>");
                               nodo4=new ArbolSintactico(nodo5,null,90,34,"",evento);
                               nodo4.estableceSt("</apply>");
                               nodo3=new ArbolSintactico(nodo4,null,90,2,"Elija la opcion que quiera para el operador",evento);
                               nodo2=new ArbolSintactico(nodo3,null,90,33,"",evento);
                               nodo2.estableceSt("<apply>");
                               nodo1=new ArbolSintactico(nodo2,null,90,98,"",evento);
                               nodo1.estableceSt("<condition>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
			      if(st.equals("especificar condicion con un conjunto"))
                              {
                               nodo5=new ArbolSintactico(null,null,91,99,"",evento);
                               nodo5.estableceSt("</condition>");
                               nodo4=new ArbolSintactico(nodo5,null,91,47,"",evento);
                               nodo4.estableceSt("</set>");
                               nodo3=new ArbolSintactico(nodo4,null,91,12,"Elija la opcion de especificar el conjunto con condicion o sin ella",evento);
                               nodo2=new ArbolSintactico(nodo3,null,91,46,"",evento);
                               nodo2.estableceSt("<set>");
                               nodo1=new ArbolSintactico(nodo2,null,91,98,"",evento);
                               nodo1.estableceSt("<condition>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                              };
                              break;
		       case(8):if(st.equals("suma"))
                               {
                               nodo1=new ArbolSintactico(null,null,92,100,"",evento);
                               nodo1.estableceSt("<plus/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
		               if(st.equals("multiplicacion"))
                               {
                               nodo1=new ArbolSintactico(null,null,93,101,"",evento);
                               nodo1.estableceSt("<times/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("maximo"))
                               {
                               nodo1=new ArbolSintactico(null,null,94,102,"",evento);
                               nodo1.estableceSt("<max/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("minimo"))
                               {
                               nodo1=new ArbolSintactico(null,null,95,103,"",evento);
                               nodo1.estableceSt("<min/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("maximo comun divisor"))
                               {
                               nodo1=new ArbolSintactico(null,null,96,104,"",evento);
                               nodo1.estableceSt("<gcd/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("media"))
                               {
                               nodo1=new ArbolSintactico(null,null,97,105,"",evento);
                               nodo1.estableceSt("<mean/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("desviacion tipica"))
                               {
                               nodo1=new ArbolSintactico(null,null,98,106,"",evento);
                               nodo1.estableceSt("<sdev/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("varianza"))
                               {
                               nodo1=new ArbolSintactico(null,null,99,107,"",evento);
                               nodo1.estableceSt("<var/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("mediana"))
                               {
                               nodo1=new ArbolSintactico(null,null,100,108,"",evento);
                               nodo1.estableceSt("<median/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("moda"))
                               {
                               nodo1=new ArbolSintactico(null,null,101,109,"",evento);
                               nodo1.estableceSt("<mode/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               }; 
			       if(st.equals("seleccion en matriz"))
                               {
                               nodo1=new ArbolSintactico(null,null,102,110,"",evento);
                               nodo1.estableceSt("<select/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("and logico"))
                               {
                               nodo1=new ArbolSintactico(null,null,103,111,"",evento);
                               nodo1.estableceSt("<and/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("or logico"))
                               {
                               nodo1=new ArbolSintactico(null,null,104,112,"",evento);
                               nodo1.estableceSt("<or/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("xor logico"))
                               {
                               nodo1=new ArbolSintactico(null,null,105,113,"",evento);
                               nodo1.estableceSt("<xor/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("union de conjuntos"))
                               {
                               nodo1=new ArbolSintactico(null,null,106,114,"",evento);
                               nodo1.estableceSt("<union/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("interseccion de conjuntos"))
                               {
                               nodo1=new ArbolSintactico(null,null,107,115,"",evento);
                               nodo1.estableceSt("<intersec/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
                               break;
		      case(9):if(st.equals("integral"))
                              {
                               nodo1=new ArbolSintactico(null,null,108,116,"",evento);
                               nodo1.estableceSt("<int/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                              };
		              if(st.equals("sumatorio"))
                              {
                               nodo1=new ArbolSintactico(null,null,109,117,"",evento);
                               nodo1.estableceSt("<sum/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                              };
			      if(st.equals("producto"))
                              {
                               nodo1=new ArbolSintactico(null,null,110,118,"",evento);
                               nodo1.estableceSt("<product/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                              };
                              break;
		      case(10):if(st.equals("no igual"))
                               {
                               nodo1=new ArbolSintactico(null,null,111,119,"",evento);
                               nodo1.estableceSt("<ne/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
		               if(st.equals("relacion de conjuntos pertenece"))
                               {
                               nodo1=new ArbolSintactico(null,null,112,120,"",evento);
                               nodo1.estableceSt("<in/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("relacion de conjuntos no pertenece"))
                               {
                               nodo1=new ArbolSintactico(null,null,113,121,"",evento);
                               nodo1.estableceSt("<notin/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("relacion de conjuntos no subcojunto"))
                               {
                               nodo1=new ArbolSintactico(null,null,114,122,"",evento);
                               nodo1.estableceSt("<notsubset/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("relacion de conjuntos no subconjunto propio"))
                               {
                               nodo1=new ArbolSintactico(null,null,115,123,"",evento);
                               nodo1.estableceSt("<notprsubset/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("relacion tiende hacia ->"))
                               {
                               nodo1=new ArbolSintactico(null,null,116,124,"",evento);
                               nodo1.estableceSt("<tendsto/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
                               break;
		      case(11):if(st.equals("igual"))
                               {
                               nodo1=new ArbolSintactico(null,null,117,125,"",evento);
                               nodo1.estableceSt("<eq/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               }; 
		               if(st.equals("menor o igual"))
                               {
                               nodo1=new ArbolSintactico(null,null,118,126,"",evento);
                               nodo1.estableceSt("<leq/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("menor que"))
                               {
                               nodo1=new ArbolSintactico(null,null,119,127,"",evento);
                               nodo1.estableceSt("<lt/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("mayor o igual"))
                               {
                               nodo1=new ArbolSintactico(null,null,120,128,"",evento);
                               nodo1.estableceSt("<geq/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("mayor que"))
                               {
                               nodo1=new ArbolSintactico(null,null,121,129,"",evento);
                               nodo1.estableceSt("<gt/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("relacion de conjuntos subconjunto"))
                               {
                               nodo1=new ArbolSintactico(null,null,122,130,"",evento);
                               nodo1.estableceSt("<subset/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
			       if(st.equals("relacion de conjuntos subconjunto propio"))
                               {
                               nodo1=new ArbolSintactico(null,null,123,131,"",evento);
                               nodo1.estableceSt("<prsubset/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
                               break;
		       case(12):if(st.equals ("especifar sin condicion"))
			       {
                               nodo1=new ArbolSintactico(null,null,124,4,"Elija la opcion de si es el ultimo argumento u otro",evento);
                               nodo1.estableceSt("<condition>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
                               if(st.equals("especifar con condicion"))
			       {
                               nodo3=new ArbolSintactico(null,null,125,1,"Elija la opcion que desee",evento );
                               nodo2=new ArbolSintactico(nodo3,null,125,7,"Elija la opcion que desee para la condicion",evento);
                               nodo1=new ArbolSintactico(nodo2,null,125,5,"Elija la opcion que desee de si es la ultima variable o desea especificar mas variables",evento);
                               nodo1.estableceSt("<uplimit>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux); 
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               };
                               break;
		       case(13):if(st.equals("ultimafila"))
			        {
                               nodo3=new ArbolSintactico(null,null,126,133,"",evento );
                               nodo3.estableceSt("</matrixrow>");
                               nodo2=new ArbolSintactico(nodo3,null,126,4,"Elija una opcion de si es el ultimo argumento o hay mas",evento);
                               nodo1=new ArbolSintactico(nodo2,null,126,132,"",evento);
                               nodo1.estableceSt("<matrixrow>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux); 
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                                };
                                if (st.equals("otrafila"))
				{
                               nodo4=new ArbolSintactico(null,null,127,13,"elija opcion para otra fila",evento);
                               nodo3=new ArbolSintactico(nodo4,null,127,133,"",evento );
                               nodo3.estableceSt("</matrixrow>");
                               nodo2=new ArbolSintactico(nodo3,null,127,4,"Elija una opcion de si es el ultimo argumento o hay mas",evento);
                               nodo1=new ArbolSintactico(nodo2,null,127,132,"",evento);
                               nodo1.estableceSt("<matrixrow>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                                };
                                break;
		      case(14):if(st.equals("variable especificando grado"))
                               {
                               
			       nodo8=new ArbolSintactico(null,null,128,135,"",evento);
                               nodo8.estableceSt("</bvar>");
                               nodo7=new ArbolSintactico(nodo8,null,128,89,"",evento);
                               nodo7.estableceSt("</degree>");
                               nodo6=new ArbolSintactico(nodo7,null,128,1,"Elija la opcion que desee para el grado de la variable",evento);
                               nodo5=new ArbolSintactico(nodo6,null,128,88,"",evento);
                               nodo5.estableceSt("<degree>");
                               nodo4=new ArbolSintactico(nodo5,null,128,18,"",evento);
                               nodo4.estableceSt("</ci>");
                               nodo3=new ArbolSintactico(nodo4,null,128,16,"Elija la opcion que desee para el nombre de la variable",evento);
                               nodo2=new ArbolSintactico(nodo3,null,128,17,"",evento);
                               nodo2.estableceSt("<ci>");
                               nodo1=new ArbolSintactico(nodo2,null,128,134,"",evento);
                               nodo1.estableceSt("<bvar>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);  
                               pila.push(nodo8);
                               pila.push(nodo7);
                               pila.push(nodo6);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               };
		               if(st.equals("variable con subindice especificando grado"))
                               {
                               nodo15=new ArbolSintactico(null,null,129,135,"",evento);
                               nodo15.estableceSt("</bvar>");
                               nodo14=new ArbolSintactico(nodo15,null,129,89,"",evento);
                               nodo14.estableceSt("</degree>");
                               nodo13=new ArbolSintactico(nodo14,null,129,1,"",evento);
                               nodo12=new ArbolSintactico(nodo13,null,129,88,"",evento);
                               nodo12.estableceSt("<degree>");
                               nodo11=new ArbolSintactico(nodo12,null,129,18,"",evento);
                               nodo11.estableceSt("</ci>");
                               nodo10=new ArbolSintactico(nodo11,null,129,20,"",evento);
                               nodo10.estableceSt("</msub>");
			       nodo9=new ArbolSintactico(nodo10,null,129,22,"",evento);
                               nodo9.estableceSt("</mi>");
                               nodo8=new ArbolSintactico(nodo9,null,129,16,"Elija una opcion para el nombre del subindice",evento);
                               nodo7=new ArbolSintactico(nodo8,null,129,21,"",evento);
                               nodo7.estableceSt("<mi>");
                               nodo6=new ArbolSintactico(nodo7,null,129,22,"",evento);
                               nodo6.estableceSt("</mi>");
                               nodo5=new ArbolSintactico(nodo6,null,129,16,"Elija una opcion para el nombre de la variable",evento);
                               nodo4=new ArbolSintactico(nodo5,null,129,21,"",evento);
                               nodo4.estableceSt("<mi>");
                               nodo3=new ArbolSintactico(nodo4,null,129,19,"",evento);
                               nodo3.estableceSt("<msub>");
                               nodo2=new ArbolSintactico(nodo3,null,129,17,"",evento);
                               nodo2.estableceSt("<ci>");
                               nodo1=new ArbolSintactico(nodo2,null,129,134,"",evento);
                               nodo1.estableceSt("<bvar>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo15);
                               pila.push(nodo14);
                               pila.push(nodo13);
                               pila.push(nodo12);
                               pila.push(nodo11);   
                               pila.push(nodo10);
                               pila.push(nodo9);
                               pila.push(nodo8);
                               pila.push(nodo7);
                               pila.push(nodo6);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               };
			       if(st.equals("variable con superindice especificando grado"))
                               {
                               nodo15=new ArbolSintactico(null,null,130,135,"",evento);
                               nodo15.estableceSt("</bvar>");
                               nodo14=new ArbolSintactico(nodo15,null,130,89,"",evento);
                               nodo14.estableceSt("</degree>");
                               nodo13=new ArbolSintactico(nodo14,null,130,1,"",evento);
                               nodo12=new ArbolSintactico(nodo13,null,130,88,"",evento);
                               nodo12.estableceSt("<degree>");
                               nodo11=new ArbolSintactico(nodo12,null,130,18,"",evento);
                               nodo11.estableceSt("</ci>");
                               nodo10=new ArbolSintactico(nodo11,null,130,24,"",evento);
                               nodo10.estableceSt("</msup>");
			       nodo9=new ArbolSintactico(nodo10,null,130,22,"",evento);
                               nodo9.estableceSt("</mi>");
                               nodo8=new ArbolSintactico(nodo9,null,130,16,"Elija una opcion para el nombre del subindice",evento);
                               nodo7=new ArbolSintactico(nodo8,null,130,21,"",evento);
                               nodo7.estableceSt("<mi>");
                               nodo6=new ArbolSintactico(nodo7,null,130,22,"",evento);
                               nodo6.estableceSt("</mi>");
                               nodo5=new ArbolSintactico(nodo6,null,130,16,"Elija una opcion para el nombre de la variable",evento);
                               nodo4=new ArbolSintactico(nodo5,null,130,21,"",evento);
                               nodo4.estableceSt("<mi>");
                               nodo3=new ArbolSintactico(nodo4,null,130,23,"",evento);
                               nodo3.estableceSt("<msup>");
                               nodo2=new ArbolSintactico(nodo3,null,130,17,"",evento);
                               nodo2.estableceSt("<ci>");
                               nodo1=new ArbolSintactico(nodo2,null,130,134,"",evento);
                               nodo1.estableceSt("<bvar>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo15);
                               pila.push(nodo14);
                               pila.push(nodo13);
                               pila.push(nodo12);
                               pila.push(nodo11);   
                               pila.push(nodo10);
                               pila.push(nodo9);
                               pila.push(nodo8);
                               pila.push(nodo7);
                               pila.push(nodo6);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               };
			       if(st.equals("variable"))
                               {
                               nodo5=new ArbolSintactico(null,null,131,135,"",evento);
                               nodo5.estableceSt("</bvar>");
                               nodo4=new ArbolSintactico(nodo5,null,131,135,"",evento); 
                               nodo4.estableceSt("</ci>");
                               nodo3=new ArbolSintactico(nodo4,null,131,16,"Elija la opcion que desee para el nombre de la variable",evento);
                               nodo2=new ArbolSintactico(nodo3,null,131,17,"",evento);
                               nodo2.estableceSt("<ci>");
                               nodo1=new ArbolSintactico(nodo2,null,131,134,"",evento);
                               nodo1.estableceSt("<bvar>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux); 
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               };
			       if(st.equals("variable con subindice"))
                               {
                               nodo12=new ArbolSintactico(null,null,132,135,"",evento);
                               nodo12.estableceSt("</bvar>");
                               nodo11=new ArbolSintactico(nodo12,null,132,18,"",evento);
                               nodo11.estableceSt("</ci>");
                               nodo10=new ArbolSintactico(nodo11,null,132,20,"",evento);
                               nodo10.estableceSt("</msub>");
			       nodo9=new ArbolSintactico(nodo10,null,132,22,"",evento);
                               nodo9.estableceSt("</mi>");
                               nodo8=new ArbolSintactico(nodo9,null,132,16,"Elija una opcion para el nombre del subindice",evento);
                               nodo7=new ArbolSintactico(nodo8,null,132,21,"",evento);
                               nodo7.estableceSt("<mi>");
                               nodo6=new ArbolSintactico(nodo7,null,132,22,"",evento);
                               nodo6.estableceSt("</mi>");
                               nodo5=new ArbolSintactico(nodo6,null,132,16,"Elija una opcion para el nombre de la variable",evento);
                               nodo4=new ArbolSintactico(nodo5,null,132,21,"",evento);
                               nodo4.estableceSt("<mi>");
                               nodo3=new ArbolSintactico(nodo4,null,132,19,"",evento);
                               nodo3.estableceSt("<msub>");
                               nodo2=new ArbolSintactico(nodo3,null,132,17,"",evento);
                               nodo2.estableceSt("<ci>");
                               nodo1=new ArbolSintactico(nodo2,null,132,134,"",evento);
                               nodo1.estableceSt("<bvar>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo12);
                               pila.push(nodo11);
                               pila.push(nodo10);
                               pila.push(nodo9);
                               pila.push(nodo8);
                               pila.push(nodo7);
                               pila.push(nodo6);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               };
			       if(st.equals("variable con superindice"))
                               {
                               nodo12=new ArbolSintactico(null,null,133,135,"",evento);
                               nodo12.estableceSt("</bvar>");
                               nodo11=new ArbolSintactico(nodo12,null,133,18,"",evento);
                               nodo11.estableceSt("</ci>");
                               nodo10=new ArbolSintactico(nodo11,null,133,24,"",evento);
                               nodo10.estableceSt("</msup>");
			       nodo9=new ArbolSintactico(nodo10,null,133,22,"",evento);
                               nodo9.estableceSt("</mi>");
                               nodo8=new ArbolSintactico(nodo9,null,133,16,"Elija una opcion para el nombre del superindice",evento);
                               nodo7=new ArbolSintactico(nodo8,null,133,21,"",evento);
                               nodo7.estableceSt("<mi>");
                               nodo6=new ArbolSintactico(nodo7,null,133,22,"",evento);
                               nodo6.estableceSt("</mi>");
                               nodo5=new ArbolSintactico(nodo6,null,133,16,"Elija una opcion para el nombre de la variable",evento);
                               nodo4=new ArbolSintactico(nodo5,null,133,21,"",evento);
                               nodo4.estableceSt("<mi>");
                               nodo3=new ArbolSintactico(nodo4,null,133,23,"",evento);
                               nodo3.estableceSt("<msup>");
                               nodo2=new ArbolSintactico(nodo3,null,133,17,"",evento);
                               nodo2.estableceSt("<ci>");
                               nodo1=new ArbolSintactico(nodo2,null,133,134,"",evento);
                               nodo1.estableceSt("<bvar>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo12);
                               pila.push(nodo11);
                               pila.push(nodo10);
                               pila.push(nodo9);
                               pila.push(nodo8);
                               pila.push(nodo7);
                               pila.push(nodo6);
                               pila.push(nodo5);
                               pila.push(nodo4);
                               pila.push(nodo3);
                               pila.push(nodo2);
                               pila.push(nodo1);
                               };
                               break;
		      case(15):if(st.equals("cuantificador logico paratodo"))
                               {
                               nodo1=new ArbolSintactico(null,null,134,136,"",evento);
                               nodo1.estableceSt("<forall/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux); 
                               pila.push(nodo1);
                               };
		               if(st.equals("cuantificador logico existe"))
                               {
                               nodo1=new ArbolSintactico(null,null,135,137,"",evento);
                               nodo1.estableceSt("<exist/>");
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceHijo(nodo1);
                               basura.push(nodoaux);
                               pila.push(nodo1);
                               };
                               break;
		      case(16):if(st.equals("definicion a traves de teclado"))
                               {
				   //limpia();
				   //mat.setVisible(true);
				   //ref.setVisible(true);
				   //trad.setVisible(true);
				   //help.setVisible(true);
                               menu.setEnableDeshacer(false);
                               keyboard.setVisible(true);                               
                               meteteclado=true;
                               };
		               if(st.equals("letra alpha"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&alpha;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra beta"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&beta;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra chi"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&chi;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra delta"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&delta;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra epsiv"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&epsiv;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra eta"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&eta;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra gamma"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&gamma;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra iota"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&iota;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra kappa"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&kappa;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra lambda"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&lambda;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra mu"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&mu;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra nu"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&nu;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra omega"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&omega;");
                               basura.push(nodoaux); 
                               };
			       if(st.equals("letra omicron"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&omicron;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra phi"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&phi;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra pi"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&pi;");
                               basura.push(nodoaux); 
                               };
			       if(st.equals("letra psi"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&psi;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra rho"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&rho;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra sigma"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&sigma;");
                               basura.push(nodoaux); 
                               };
			       if(st.equals("letra tau"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&tau;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra theta"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&theta;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra upsi"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&upsi;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra xi"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&xi;");
                               basura.push(nodoaux);
                               };
			       if(st.equals("letra zeta"))
                               {
                               nodoaux=(ArbolSintactico)pila.pop();
                               nodoaux.estableceSt("&zeta;");
                               basura.push(nodoaux);
                               };
                               break;
                      };    
                   nodoaux=(ArbolSintactico)pila.peek(); 
                   while(nodoaux.token()>16 &&!pila.empty())
		       {pila.pop();
                        if(!pila.empty())
                        nodoaux=(ArbolSintactico)pila.peek();
                       };           
                   if(pila.empty())
		       {//poner opciones de salida de estado
                        
                        if(estado==7)
			    {estado =2;
                             while(!basura.empty())
				 {basura.pop();};
                             while(!referencias.empty())
				 {referencias.pop();};
                             limpia();
                             menu.setEnableInicio(true);
                             menu.setEnableTerminar(true);
                             menu.setEnableNuevoTexto(true);
                             menu.setEnableMatematicas(true);
                             menu.setEnableDeshacer(true);
                             indices.push(new Integer(menu.getIndex()));
                             nodopadre.escribe(menu.devuelveArea());                        
                            }
                        else
                        {estado=8;
                         while(!basura.empty())
			 {basura.pop();};
                         while(!referencias.empty())
			     {referencias.pop();};
                          limpia();
                          menu.setEnableInicio(true);
                          menu.setEnableTerminar(true);
                          menu.setEnableNuevoTexto(true);
                          menu.setEnableMatematicas(true);
                          nodopadre.escribea(menu.devuelveArea());
                        };
                                              
                      (Runtime.getRuntime()).gc();
                       }
                   else
		       {//poner opciones de la cima de la pila
                       nodoaux=(ArbolSintactico)pila.peek();
                       mat.activamenumat(nodoaux.token());
                       help.setText(nodoaux.devuelveInfo());
                       }; 
                 };
                 };
                 evento++;
                 };
                 ref.setText("");
                 while(!referencias.empty())
		     {ref.insertText(((String)referencias.peek()));
                      referenciasaux.push(referencias.pop());
                     };
                 while(!referenciasaux.empty())
		     {referencias.push(referenciasaux.pop());};
                 if(estado==7||estado==9)
		 {
                 trad.setText("</BODY>");  
                 nodopadre.escribe(trad.devuelveText());
                 }
                 else
                 {trad.setText("</BODY>");
                 };
                 break;
		         
         case(8):if(st.equals("Terminar"))
	         {estado=11;
                  cierre.setVisible(true);
                 };
                 if(st.equals("Matematicas"))
		 {estado=9;
                  limpia();
                  trad.setVisible(true);
                  ref.setVisible(true);
                  help.setVisible(true);
                  mat.setVisible(true);
                  mat.activamenumat(1);
                  help.setText("Elija la opcion que desee");
                  menu.setEnableDeshacer(true);
                  evento=1;
                  nodopadre=new ArbolSintactico(null,null,1,1,"Elija la opcion que desee",0);
                  pila.push(nodopadre);
                 };
                 if(st.equals("Nuevo texto"))
		 {estado=10;
                  limpia();
                  keya.setVisible(true);
                 };
                 if(st.equals("Inicio"))
		 {estado=1;
		  menu.setText("<HTML>\n<HEAD>\n</HEAD>\n<BODY>\n\n\n</BODY>\n</HTML>");
                  menu.setEditable(false);
                  limpia();
                  menu.setEnableUsuarioNormal(true);
                  menu.setEnableUsuarioAvanzado(true);
                 };
                 break;              
	 case(10):if(st.equals("parrafo"))
	          {estado=8;
                   limpia();
                   ind=menu.getCaretPosition();
                   menu.setEnableInicio(true);
                   menu.setEnableTerminar(true);
                   menu.setEnableNuevoTexto(true);
                   menu.setEnableMatematicas(true);
                   menu.setTextC("<P> </P>");
                   menu.setCaretPosition(ind+8);
                   menu.setCaretPosition(menu.getCaretPosition()-5);
                  };
                  if(st.equals("saltolinea"))
		  {estado=8;
                   limpia();
                   menu.setEnableInicio(true);
                   menu.setEnableTerminar(true);
                   menu.setEnableNuevoTexto(true);
                   menu.setEnableMatematicas(true);
                   menu.setTextC("<BR>"); 
                  };
                  if(st.equals("cursiva"))
		  {estado=8;
                   limpia();
                   ind=menu.getCaretPosition();
                   menu.setEnableInicio(true);
                   menu.setEnableTerminar(true);
                   menu.setEnableNuevoTexto(true);
                   menu.setEnableMatematicas(true);
                   menu.setTextC("<I> </I>");
                   menu.setCaretPosition(ind+8);
                   menu.setCaretPosition(menu.getCaretPosition()-5); 
                  };
                  if(st.equals("subrayado"))
		  {estado=8;
                   limpia();
                   ind=menu.getCaretPosition();
                   menu.setEnableInicio(true);
                   menu.setEnableTerminar(true);
                   menu.setEnableNuevoTexto(true);
                   menu.setEnableMatematicas(true);
                   menu.setTextC("<U> </U>");
                   menu.setCaretPosition(ind+8); 
                   menu.setCaretPosition(menu.getCaretPosition()-5);
                  };
                  if(st.equals("negrita"))
		  {estado=8;
                   limpia();
                   ind=menu.getCaretPosition();
                   menu.setEnableInicio(true);
                   menu.setEnableTerminar(true);
                   menu.setEnableNuevoTexto(true);
                   menu.setEnableMatematicas(true);
                   menu.setTextC("<B> </B>");
                   menu.setCaretPosition(ind+8);
                   menu.setCaretPosition(menu.getCaretPosition()-5);
            
                  };
                 break;
         case(11):if(st.equals("aceptar"))
	         {estado=8;
                  limpia();
                  menu.setEnableInicio(true);
                  menu.setEnableTerminar(true);
                  menu.setEnableNuevoTexto(true);
                  menu.setEnableMatematicas(true);
                 };
                 break;              	            
         };








     if(st.equals(""))
	 {}; 
    };
    
};
//*****************************************************************************************
//Final de la clase editor
//*****************************************************************************************



















